@echo off
rem this batch file works only if these conditions are met.
rem
rem 1. The batch file should be executed from the directory where it resides.
rem
rem 2. All the referenced jar files should exist in the directory where this
rem    batch file exists.  The required jar files are:
rem    a) cwconverter.jar
rem    b) xerces.jar (version 1.4.2, extracted from wsadie org.apache.xerces plugin)
rem    c) xalan.jar (version 2.0. update Sept 04, 2001, extracted from wsadie com.ibm.etools.xalanrt plugin) 
rem
rem 3. The xslt files should be located in a converter specific sub-directory
rem    "com.ibm.btools.itools.cwconverter/xsls". The directory path is dictated by cwconverter plugin because
rem    cwconverter.jar is used as Eclipse plugin for CSM.
rem    For example, for CWPT-to-BPEL converters, these files are required (assuming there are three xsl files):
rem    a) ./com.ibm.btools.itools.cwconverter/xsls/CWPT_BPEL/WSBPFlow.xsl
rem    b) ./com.ibm.btools.itools.cwconverter/xsls/CWPT_BPEL/WSBPWsdl.xsl
rem    c) ./com.ibm.btools.itools.cwconverter/xsls/CWPT_BPEL/BPELGUI.xsl
rem
rem For the parameter usage of CWConverter, execute it with -h switch.
rem If no parameters are given, the converter starts up as a generic converter
rem that shows all implemented CrossWorlds converters in a list.
rem
@echo on

java -cp ./cwconverter.jar;./cwconvlang.jar;./xerces.jar;./xalan.jar;./xercesImpl.jar -DCWTools.home="%CROSSWORLDS%"\bin  com.ibm.btools.itools.cwconverter.CWConverter %1 %2 %3
