<?xml version="1.0" encoding="UTF-8"?>

<!--
	* Licensed Materials - Property of IBM
	* 5724-C11, 5724-C13, 5724-D17
	* (C) Copyright IBM Corporation 1997, 2003. All Rights Reserved.
	* US Government Users Restricted Rights- Use, duplication or disclosure
	* restricted by GSA ADP Schedule Contract with IBM Corp.
-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="xml" indent="yes"/>
	<xsl:strip-space elements="*"/>

	<xsl:param name="gui-diagram-file"/>
	<xsl:variable name="t" select="/CollabTemplate/@Name"/>

	<xsl:template match="/">
		<xsl:apply-templates select="CollabTemplate"/>
	</xsl:template>

	<xsl:template match="CollabTemplate|TemplateDefinition|Scenarios|Scenarios/Scenario">
		<xsl:element name="{name()}">
			<xsl:for-each select="@*">
				<xsl:attribute name="{name()}">
					<xsl:value-of select="."/>
				</xsl:attribute>
			</xsl:for-each>

			<xsl:for-each select="*">
				<xsl:apply-templates select="."/>
			</xsl:for-each>
		</xsl:element>
	</xsl:template>

	<xsl:template match="Scenarios/Scenario/GUIDiagrams">
		<xsl:variable name="s" select="../@Name"/>
		<xsl:copy-of select= "document($gui-diagram-file)/*/CollabTemplate[@Name=$t]/*/Scenario[@Name=$s]/GUIDiagrams"/>
	</xsl:template>

	<xsl:template match="TemplateDefinition/BusObjRefs">
		<xsl:copy-of select= "document($gui-diagram-file)/*/CollabTemplate[@Name=$t]//TemplateDefinition/BusObjRefs"/>
	</xsl:template>

	<!--the default template that makes straight-out copies-->
	<xsl:template match="*">
		<xsl:copy-of select="."/>
	</xsl:template>
</xsl:stylesheet>
