<?xml version="1.0" encoding="UTF-8"?>

<xsl:stylesheet 
	version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 	
	xmlns:xalan="http://xml.apache.org/xalan"
	xmlns:slnk="http://schemas.xmlsoap.org/ws/2002/07/service-link/" 
	xmlns:wpc="http://www.ibm.com/schemas/workflow/bpe" 
	xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/" 
	xmlns:java="http://xml.apache.org/xslt/java"	
	exclude-result-prefixes="xalan slnk wsdl wpc java">

	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>	
	<xsl:param name="wsdlServiceInfo" />
	<xsl:param name="wsdlDefinitions" />
	<xsl:param name="pdProcess" />

	<xsl:strip-space elements="*" />

	<!-- 
	***************************************************************************************************************************************************************************
	Global variable definitions
	***************************************************************************************************************************************************************************
	-->

	<xsl:variable name="bUseXPATHExpression" select="0" />

	<xsl:variable name="objXSLTUtils" select="java:com.ibm.btools.itools.cwconverter.xslt.ext.XSLTUtils.new()"/>	

	<!-- *** Format utility variables *** -->

	<xsl:variable name="newline">
	<xsl:text>
	</xsl:text>
	</xsl:variable>	

	<xsl:template match="/">

		<xsl:variable name="strExecutionMode">
			<xsl:choose>
				<xsl:when test="/CollabTemplate/TemplateDefinition/Properties/Property[@Name = 'SystemProperties']/Attributes/Attribute[@Name = 'LongLivedBusinessProcess']/Value = 'false'">
					<xsl:value-of select="'microflow'" />
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="'longRunning'" />
				</xsl:otherwise>
			</xsl:choose>			
		</xsl:variable>

	
		<xsl:text disable-output-escaping="yes">&lt;process name="</xsl:text><xsl:value-of select="normalize-space(/CollabTemplate/@Name)" /><xsl:text disable-output-escaping="yes">"</xsl:text>
		<xsl:text disable-output-escaping="yes"> wpc:executionMode="</xsl:text><xsl:value-of select="$strExecutionMode" /><xsl:text disable-output-escaping="yes">"</xsl:text>
		<xsl:text disable-output-escaping="yes"> targetNamespace="</xsl:text><xsl:value-of select="concat('http://tempuri.org/IBM/WBI/', normalize-space(/CollabTemplate/@Name))" /><xsl:text disable-output-escaping="yes">"</xsl:text>
		<xsl:text disable-output-escaping="yes"> xmlns:tns="</xsl:text><xsl:value-of select="concat('http://tempuri.org/IBM/WBI/', normalize-space(/CollabTemplate/@Name))" /><xsl:text disable-output-escaping="yes">"</xsl:text>
		<xsl:text disable-output-escaping="yes"> xmlns:xsd="</xsl:text><xsl:value-of select="'http://www.w3.org/2000/10/XMLSchema'" /><xsl:text disable-output-escaping="yes">"</xsl:text>
		<xsl:text disable-output-escaping="yes"> xmlns:xsdGeneric="</xsl:text><xsl:value-of select="'http://tempuri.org/IBM/WBI/genericSchemas'" /><xsl:text disable-output-escaping="yes">"</xsl:text>
		<xsl:text disable-output-escaping="yes"> xmlns:xsdWBI="</xsl:text><xsl:value-of select="concat('http://tempuri.org/IBM/WBI/', normalize-space(/CollabTemplate/@Name), '/schemas')" /><xsl:text disable-output-escaping="yes">"</xsl:text>
		<xsl:text disable-output-escaping="yes"> xmlns:wsdlWBI="</xsl:text><xsl:value-of select="concat('http://tempuri.org/IBM/WBI/', normalize-space(/CollabTemplate/@Name), '/definitions')" /><xsl:text disable-output-escaping="yes">"</xsl:text>
		<xsl:text disable-output-escaping="yes"> xmlns:wsdl="</xsl:text><xsl:value-of select="'http://schemas.xmlsoap.org/wsdl/'" /><xsl:text disable-output-escaping="yes">"</xsl:text>
		<xsl:text disable-output-escaping="yes"> xmlns:slnk="</xsl:text><xsl:value-of select="'http://schemas.xmlsoap.org/ws/2002/07/service-link/'" /><xsl:text disable-output-escaping="yes">"</xsl:text>
		<xsl:text disable-output-escaping="yes"> xmlns:wpc="</xsl:text><xsl:value-of select="'http://www.ibm.com/schemas/workflow/bpe'" /><xsl:text disable-output-escaping="yes">"</xsl:text>		
		<xsl:text disable-output-escaping="yes"> xmlns:bpws="</xsl:text><xsl:value-of select="'http://schemas.xmlsoap.org/ws/2002/07/business-process/'" /><xsl:text disable-output-escaping="yes">"</xsl:text>		
		<xsl:text disable-output-escaping="yes"> xmlns="</xsl:text><xsl:value-of select="'http://schemas.xmlsoap.org/ws/2002/07/business-process/'" /><xsl:text disable-output-escaping="yes">"></xsl:text>		
			<xsl:value-of select="$newline" />

			<xsl:element name="import">
				<xsl:attribute name="namespace">
					<xsl:value-of select="concat('http://tempuri.org/IBM/WBI/', normalize-space(/CollabTemplate/@Name), '/schemas')" />
				</xsl:attribute>				
				<xsl:attribute name="location">
					<xsl:value-of select="concat('http://tempuri.org/IBM/WBI/', normalize-space(/CollabTemplate/@Name), '/', normalize-space(/CollabTemplate/@Name), '.xsd')" />
				</xsl:attribute>								
			</xsl:element>	


			<xsl:text disable-output-escaping="yes">&lt;wpc:description></xsl:text>	
				<xsl:value-of select="normalize-space(/CollabTemplate/TemplateDefinition/Desc)" />
			<xsl:text disable-output-escaping="yes">&lt;/wpc:description></xsl:text>	

			<xsl:call-template name="writeGlobals" />
			<xsl:value-of select="$newline" />

			<xsl:call-template name="writeCustomProperties" />
			<xsl:value-of select="$newline" />

			<xsl:call-template name="writePartners" />
			<xsl:value-of select="$newline" />

			<xsl:call-template name="writeVariables" />
			<xsl:value-of select="$newline" />

			<xsl:call-template name="writeCorrelationSets" />
			<xsl:value-of select="$newline" />

			<xsl:call-template name="writeProcessFaultHandlers" />
			<xsl:value-of select="$newline" />

			<xsl:call-template name="writeScenarios" />
			<xsl:value-of select="$newline" />			

		<xsl:text disable-output-escaping="yes">
			&lt;/process>
		</xsl:text>	
				
	</xsl:template>

	<xsl:template name="writeGlobals">
		<xsl:text disable-output-escaping="yes">&lt;wpc:globals language="Java"></xsl:text>
			<xsl:variable name="strSourceStatements">
				<xsl:for-each select="/CollabTemplate/TemplateDefinition/Properties/Property[@Name = 'Imports']/Attributes/Attribute">
					<xsl:value-of select="Value" />
					<xsl:value-of select="$newline" />	
				</xsl:for-each>											
			</xsl:variable>

			<xsl:variable name="nodeImports" select="java:GetAllImports($objXSLTUtils, $strSourceStatements)" />

			<xsl:for-each select="$nodeImports">
				<xsl:text disable-output-escaping="yes">&lt;wpc:import packages="</xsl:text>	
					<xsl:value-of select="." />
				<xsl:text disable-output-escaping="yes">" /></xsl:text>
				<xsl:value-of select="$newline" />				
			</xsl:for-each>			
		<xsl:text disable-output-escaping="yes">&lt;/wpc:globals></xsl:text>
	</xsl:template>

	<xsl:template name="writeCustomProperties">			
		<xsl:if test="count(/CollabTemplate/GUITemplateDefinition/GUIProperties/*/GUIProperty | /CollabTemplate/Scenarios/Scenario[*]/GUIDiagrams/GUIDiagram[*]/GUIProperties/*/GUIProperty) &gt; 0">			
			<xsl:text disable-output-escaping="yes">&lt;wpc:customProperties></xsl:text>
					<xsl:for-each select="/CollabTemplate/GUITemplateDefinition/GUIProperties/*/GUIProperty | /CollabTemplate/Scenarios/Scenario[*]/GUIDiagrams/GUIDiagram[*]/GUIProperties/*/GUIProperty">
						<xsl:text disable-output-escaping="yes">&lt;wpc:customProperty name="</xsl:text>
								<xsl:value-of select="normalize-space(@Name)" />						
						<xsl:text disable-output-escaping="yes">" isConfigProperty="true"></xsl:text>

						<xsl:text disable-output-escaping="yes">&lt;wpc:value></xsl:text>
								<xsl:value-of select="DefaultValues/Values/GUIPropertyValue" />						
						<xsl:text disable-output-escaping="yes">&lt;/wpc:value></xsl:text>
						<xsl:text disable-output-escaping="yes">&lt;/wpc:customProperty></xsl:text>
					</xsl:for-each>												
			<xsl:text disable-output-escaping="yes">&lt;/wpc:customProperties></xsl:text>
		</xsl:if>
	</xsl:template>


	<xsl:template name="writePartners">
		<xsl:if test="count(document($wsdlDefinitions)/*/slnk:serviceLinkType) &gt; 0">		
			<xsl:element name="partners">
				<xsl:for-each select="document($wsdlDefinitions)/*/slnk:serviceLinkType" >					
					<xsl:element name="partner">
						<xsl:attribute name="name">
							<xsl:value-of select="@name" />						
						</xsl:attribute>
						<xsl:attribute name="serviceLinkType">
							<xsl:value-of select="concat('wsdlWBI:', @name)" />						
						</xsl:attribute>
						<xsl:if test="slnk:role[*]/@name = 'roleProvider'">
							<xsl:attribute name="myRole">
								<xsl:value-of select="slnk:role[@name = 'roleProvider']/@name" />						
							</xsl:attribute>
						</xsl:if>
						<xsl:if test="slnk:role[*]/@name = 'roleRequester'">
							<xsl:attribute name="partnerRole">
								<xsl:value-of select="slnk:role[@name = 'roleRequester']/@name" />						
							</xsl:attribute>
						</xsl:if>

					</xsl:element>
				</xsl:for-each>
			</xsl:element>
		</xsl:if>
	</xsl:template>

	<xsl:template name="writeVariables">
		<xsl:element name="variables">
			<xsl:call-template name="writeVariablesFromPorts" />

			<xsl:call-template name="writeVariablesForGenericObjects" />

			<xsl:call-template name="writeVariablesForProcess" />				

			<xsl:call-template name="writeVariablesForIterators" />							

			<xsl:for-each select="/CollabTemplate/Scenarios/Scenario[*]/ModelScenario/Diagram[*]/Declaration">								
				<xsl:call-template name="writeVariablesForScenario">					
					<xsl:with-param name="strPrefix" select="concat(normalize-space(./../../../@Name), '_')" />
					<xsl:with-param name="nodeGUIVariables" select="./../../../GUIDefinition/GUIVariables" />
				</xsl:call-template>				
			</xsl:for-each>
		</xsl:element>		
	</xsl:template>

	<xsl:template name="writeVariablesFromPorts">
		<xsl:for-each select="/CollabTemplate/TemplateDefinition/BusObjRefs/BusObjRef">
			<xsl:element name="variable">
				<xsl:attribute name="name">
					<xsl:value-of select="concat(normalize-space(@Name), 'BusObj')" />						
				</xsl:attribute>
				<xsl:variable name="strElementName" select="concat('xsdWBI:',  normalize-space(@BusObjType))" />
				<xsl:choose>
					<xsl:when test="document($wsdlDefinitions)/*/wsdl:message[*]/wsdl:part[@element = $strElementName]">
						<xsl:attribute name="messageType">							
							<xsl:value-of select="concat('wsdlWBI:', document($wsdlDefinitions)/*/wsdl:message[wsdl:part[@element = $strElementName]]/@name)" />
						</xsl:attribute>						
					</xsl:when>
					<xsl:otherwise>
						<xsl:text disable-output-escaping="yes">&lt;wsdl:message name="</xsl:text>
								<xsl:value-of select="concat(normalize-space(@BusObjType), 'Message')" />
						<xsl:text disable-output-escaping="yes">"></xsl:text>		 						

							<xsl:element name="part">
								<xsl:attribute name="name">
									<xsl:value-of select="normalize-space(@BusObjType)" />						
								</xsl:attribute>
								<xsl:attribute name="type">
									<xsl:value-of select="concat('xsdWBI:', normalize-space(@BusObjType))" />						
								</xsl:attribute>
							</xsl:element>							
					<xsl:text disable-output-escaping="yes">&lt;/wsdl:message></xsl:text>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:element>
		</xsl:for-each>
	</xsl:template>

	<xsl:template name="writeVariablesForGenericObjects">		

		<xsl:call-template name="writeTrigerringBusObjVariables" />

		<xsl:element name="variable">
			<xsl:attribute name="name">
				<xsl:value-of select="'currentException'" />						
			</xsl:attribute>
			<xsl:attribute name="messageType">							
				<xsl:value-of select="'wsdlWBI:genericFaultMessage'" />
			</xsl:attribute>						
		</xsl:element>

		<xsl:element name="variable">
			<xsl:attribute name="name">
				<xsl:value-of select="'scenarioTriggeringConditionVar'" />						
			</xsl:attribute>

			<xsl:text disable-output-escaping="yes">&lt;wsdl:message name="</xsl:text>
					<xsl:value-of select="'conditionMessage'" />
			<xsl:text disable-output-escaping="yes">"></xsl:text>		 						

				<xsl:element name="part">
					<xsl:attribute name="name">
						<xsl:value-of select="'value'" />						
					</xsl:attribute>
					<xsl:attribute name="type">
						<xsl:value-of select="'xsd:string'" />						
					</xsl:attribute>
				</xsl:element>							
			<xsl:text disable-output-escaping="yes">&lt;/wsdl:message></xsl:text>
		</xsl:element>
		
		<xsl:element name="variable">
			<xsl:attribute name="name">
				<xsl:value-of select="'exceptionConditionVar'" />						
			</xsl:attribute>

			<xsl:text disable-output-escaping="yes">&lt;wsdl:message name="</xsl:text>
					<xsl:value-of select="'conditionMessage'" />
			<xsl:text disable-output-escaping="yes">"></xsl:text>		 						

				<xsl:element name="part">
					<xsl:attribute name="name">
						<xsl:value-of select="'value'" />						
					</xsl:attribute>
					<xsl:attribute name="type">
						<xsl:value-of select="'xsd:string'" />						
					</xsl:attribute>
				</xsl:element>							
			<xsl:text disable-output-escaping="yes">&lt;/wsdl:message></xsl:text>
		</xsl:element>

	</xsl:template>

	<xsl:template name="writeTrigerringBusObjVariables">
		<xsl:for-each select="xalan:distinct(document($wsdlServiceInfo)/*/tempServiceLinkType/IsRequestResponse[@type = 'Yes']/@variable)">
			<xsl:element name="variable">
				<xsl:attribute name="name">
					<xsl:value-of select="." />						
				</xsl:attribute>
				<xsl:attribute name="messageType">							
					<xsl:variable name="strElementName" select="concat('xsdWBI:',  normalize-space(./../../@BusObjType))" />
					<xsl:value-of select="concat('wsdlWBI:', document($wsdlDefinitions)/*/wsdl:message[wsdl:part[@element = $strElementName]]/@name)" />
				</xsl:attribute>						
			</xsl:element>
		</xsl:for-each>

	</xsl:template>

	<xsl:template name="writeVariablesForProcess">						
		<xsl:variable name="strSourceStatements">
			<xsl:value-of select="'class A {'" />
			<xsl:value-of select="$newline" />	
				<xsl:for-each select="/CollabTemplate/TemplateDefinition/Properties/Property[@Name = 'Declaration']/Attributes/Attribute">
					<xsl:value-of select="Value" />
					<xsl:value-of select="$newline" />	
				</xsl:for-each>				
			<xsl:value-of select="'}'" />														
		</xsl:variable>

		<xsl:call-template name="writeUserDefinedVariables">
			<xsl:with-param name="nodeVariables" select="java:GetAllVariables($objXSLTUtils, $strSourceStatements)" />
			<xsl:with-param name="nodeGUIVariables" select="/CollabTemplate/GUITemplateDefinition/GUIVariables" />
		</xsl:call-template>

	</xsl:template>

	<xsl:template name="writeVariablesForScenario">					
	<xsl:param name="nodeGUIVariables" />
	<xsl:param name="strPrefix" select="''" />
		<xsl:variable name="strSourceStatements">
			<xsl:value-of select="concat('class A {', Section1, Section2, '}')" />
		</xsl:variable>

		<xsl:call-template name="writeUserDefinedVariables">
			<xsl:with-param name="nodeVariables" select="java:GetAllVariables($objXSLTUtils, $strSourceStatements)" />
			<xsl:with-param name="nodeGUIVariables" select="$nodeGUIVariables"/>
			<xsl:with-param name="strPrefix" select="$strPrefix" />
		</xsl:call-template>

	</xsl:template>

	<xsl:template name="writeUserDefinedVariables">
	<xsl:param name="nodeVariables" />
	<xsl:param name="nodeGUIVariables" />
	<xsl:param name="strPrefix" select="''" />

		<xsl:for-each select="$nodeVariables">

				
				<xsl:element name="variable">
					<xsl:attribute name="name">
						<xsl:value-of select="concat($strPrefix, normalize-space(name))" />						
					</xsl:attribute>

					<xsl:text disable-output-escaping="yes">&lt;wsdl:message name="</xsl:text>
							<xsl:value-of select="concat(normalize-space(type), 'Message')" />						
					<xsl:text disable-output-escaping="yes">"></xsl:text>		 						

							<xsl:variable name="strVarType" select="normalize-space(type)" />

							<xsl:element name="part">
								<xsl:attribute name="name">
									<xsl:value-of select="normalize-space('value')" />						
								</xsl:attribute>
								<xsl:attribute name="type">
								<xsl:choose>
									<xsl:when test="$strVarType = 'byte' or $strVarType = 'Byte'">
										<xsl:value-of select="'xsd:byte'" />										
									</xsl:when>
									<xsl:when test="$strVarType = 'short' or $strVarType = 'Short'">
										<xsl:value-of select="'xsd:short'" />										
									</xsl:when>
									<xsl:when test="$strVarType = 'int' or $strVarType = 'Integer'">
										<xsl:value-of select="'xsd:int'" />										
									</xsl:when>
									<xsl:when test="$strVarType = 'long' or $strVarType = 'Long'">
										<xsl:value-of select="'xsd:long'" />
									</xsl:when>
									<xsl:when test="$strVarType = 'boolean' or $strVarType = 'Boolean'">
										<xsl:value-of select="'xsd:boolean'" />										
									</xsl:when>
									<xsl:when test="$strVarType = 'float' or $strVarType = 'Float'">
										<xsl:value-of select="'xsd:float'" />										
									</xsl:when>
									<xsl:when test="$strVarType = 'double' or $strVarType = 'Double'">
										<xsl:value-of select="'xsd:double'" />										
									</xsl:when>
									<xsl:when test="$strVarType = 'String' ">
										<xsl:value-of select="'xsd:string'" />										
									</xsl:when>
									<xsl:when test="$strVarType = 'Date'">
										<xsl:value-of select="'xsd:datetime'" />										
									</xsl:when>
									<xsl:when test="$strVarType = 'BusObj'">
										<xsl:variable name="strVarName" select="normalize-space(name)" />
										<xsl:variable name="nodeGUIDefinition" select="$nodeGUIVariables/GUIVariable[normalize-space(VarName) = $strVarName and ObjectType = 'BusObj']" />
										<xsl:choose>
											<xsl:when test="$nodeGUIDefinition">
												<xsl:value-of select="concat('xsdWBI:', normalize-space(VarType))" />						
											</xsl:when>
											<xsl:otherwise>
												<xsl:value-of select="concat('xsdWBI:', normalize-space($strVarType))" />						
											</xsl:otherwise>
										</xsl:choose>										
									</xsl:when>
									<xsl:otherwise>
										<xsl:value-of select="concat('xsdWBI:', normalize-space($strVarType))" />						
									</xsl:otherwise>
								</xsl:choose>
								</xsl:attribute>

							</xsl:element>
						
					<xsl:text disable-output-escaping="yes">&lt;/wsdl:message></xsl:text>
				</xsl:element>
		</xsl:for-each>
	</xsl:template>				

	<xsl:template name="writeVariablesFromGUIVariables">
	<xsl:param name="nodeGUIVariables" />
	<xsl:param name="strPrefix" select="''" />
		<xsl:for-each select="$nodeGUIVariables/GUIVariable">
			<xsl:if test="not(VarType = '') and not(VarName = '')">
				<xsl:element name="variable">
					<xsl:attribute name="name">
						<xsl:value-of select="concat($strPrefix, normalize-space(VarName))" />						
					</xsl:attribute>

					<xsl:text disable-output-escaping="yes">&lt;wsdl:message name="</xsl:text>
							<xsl:value-of select="concat(normalize-space(VarType), 'Message')" />						
					<xsl:text disable-output-escaping="yes">"></xsl:text>		 						

							<xsl:variable name="strVarType" select="normalize-space(VarType)" />

							<xsl:element name="part">
								<xsl:attribute name="name">
									<xsl:value-of select="normalize-space(VarType)" />						
								</xsl:attribute>
								<xsl:attribute name="type">
								<xsl:choose>
									<xsl:when test="$strVarType = 'byte' or $strVarType = 'Byte'">
										<xsl:value-of select="'xsd:byte'" />										
									</xsl:when>
									<xsl:when test="$strVarType = 'short' or $strVarType = 'Short'">
										<xsl:value-of select="'xsd:short'" />										
									</xsl:when>
									<xsl:when test="$strVarType = 'int' or $strVarType = 'Integer'">
										<xsl:value-of select="'xsd:int'" />										
									</xsl:when>
									<xsl:when test="$strVarType = 'long' or $strVarType = 'Long'">
										<xsl:value-of select="'xsd:long'" />
									</xsl:when>
									<xsl:when test="$strVarType = 'boolean' or $strVarType = 'Boolean'">
										<xsl:value-of select="'xsd:boolean'" />										
									</xsl:when>
									<xsl:when test="$strVarType = 'float' or $strVarType = 'Float'">
										<xsl:value-of select="'xsd:float'" />										
									</xsl:when>
									<xsl:when test="$strVarType = 'double' or $strVarType = 'Double'">
										<xsl:value-of select="'xsd:double'" />										
									</xsl:when>
									<xsl:when test="$strVarType = 'String' ">
										<xsl:value-of select="'xsd:string'" />										
									</xsl:when>
									<xsl:when test="$strVarType = 'Date'">
										<xsl:value-of select="'xsd:datetime'" />										
									</xsl:when>
									<xsl:otherwise>
										<xsl:value-of select="concat('xsdWBI:', normalize-space(VarType))" />						
									</xsl:otherwise>
								</xsl:choose>
								</xsl:attribute>

							</xsl:element>
						
					<xsl:text disable-output-escaping="yes">&lt;/wsdl:message></xsl:text>
				</xsl:element>
			</xsl:if>
		</xsl:for-each>
	</xsl:template>

	
	<xsl:template name="writeVariablesForIterators">
		<xsl:for-each select="document($pdProcess)/*/Scenarios/Scenario[*]/pd.nodes//IteratorNode">
			<xsl:variable name="strLabel">
				<xsl:call-template name="writeLabel" />
			</xsl:variable>
			<xsl:if test="pd.type = 'Attribute'">					
				<xsl:element name="variable">
					<xsl:attribute name="name">
						<xsl:value-of select="concat('canContinueVar_', normalize-space($strLabel))" />						
					</xsl:attribute>

					<xsl:text disable-output-escaping="yes">&lt;wsdl:message name="</xsl:text>
							<xsl:value-of select="concat('bool', normalize-space($strLabel), 'Message')" />						
					<xsl:text disable-output-escaping="yes">"></xsl:text>		 						

							<xsl:element name="part">
								<xsl:attribute name="name">
									<xsl:value-of select="'value'" />						
								</xsl:attribute>
								<xsl:attribute name="type">
									<xsl:value-of select="'xsdWBI:boolean'" />						
								</xsl:attribute>

							</xsl:element>
						
					<xsl:text disable-output-escaping="yes">&lt;/wsdl:message></xsl:text>
				</xsl:element>
			</xsl:if>

			<xsl:element name="variable">
				<xsl:attribute name="name">
					<xsl:value-of select="concat('loopIndexVar_', normalize-space($strLabel))" />						
				</xsl:attribute>

				<xsl:text disable-output-escaping="yes">&lt;wsdl:message name="</xsl:text>
						<xsl:value-of select="concat('integral', normalize-space($strLabel), 'Message')" />						
				<xsl:text disable-output-escaping="yes">"></xsl:text>		 						

						<xsl:element name="part">
							<xsl:attribute name="name">
								<xsl:value-of select="'value'" />						
							</xsl:attribute>
							<xsl:attribute name="type">
								<xsl:value-of select="'xsdWBI:long'" />						
							</xsl:attribute>

						</xsl:element>
					
				<xsl:text disable-output-escaping="yes">&lt;/wsdl:message></xsl:text>
			</xsl:element>
		</xsl:for-each>
	</xsl:template>


	<xsl:template name="writeCorrelationSets">
		<xsl:if test="count(document($pdProcess)/*/CorrelationSets/CorrelationSet) &gt; 0">
			<xsl:element name="correlationSets">
				<xsl:for-each select="document($pdProcess)/*/CorrelationSets/CorrelationSet">
					<xsl:element name="correlationSet">
						<xsl:attribute name="name">
							<xsl:value-of select="@pd.name" />
						</xsl:attribute>
						<xsl:attribute name="properties">
							<xsl:value-of select="normalize-space(@pd.properties)" />
						</xsl:attribute>
					</xsl:element>
				</xsl:for-each>								
			</xsl:element>
		</xsl:if>
	</xsl:template>

	<xsl:template name="writeProcessFaultHandlers">
		<xsl:element name="faultHandlers">

			<xsl:element name="catch">
				<xsl:attribute name="faultVariable">
					<xsl:value-of select="'currentException'" />
				</xsl:attribute>

				<xsl:variable name="nodeTempScenarioInfo" select="document($wsdlServiceInfo)/*/tempServiceLinkType[*]/IsRequestResponse/tempPortType[*]/tempScenarios/tempScenarioInfo" />				
				
				<xsl:choose>
					<xsl:when test="count($nodeTempScenarioInfo) = 1">
						<xsl:element name="reply">
							<xsl:attribute name="name">
								<xsl:call-template name="writeLabel" />
							</xsl:attribute>

							<xsl:attribute name="partner">
								<xsl:value-of select="$nodeTempScenarioInfo/../../../../@name" />
							</xsl:attribute>
							<xsl:attribute name="portType">
								<xsl:value-of select="concat('wsdlWBI:', $nodeTempScenarioInfo/../../@name)" />
							</xsl:attribute>
							<xsl:attribute name="operation">
								<xsl:value-of select="$nodeTempScenarioInfo/@verb" />
							</xsl:attribute>
							<xsl:attribute name="variable">
								<xsl:value-of select="'currentException'" />
							</xsl:attribute>

						</xsl:element>
					</xsl:when>
					<xsl:when test="count($nodeTempScenarioInfo) &gt; 1">

						<xsl:element name="switch">

							<xsl:for-each select="$nodeTempScenarioInfo">
								<xsl:element name="case">
									<xsl:attribute name="condition">
										<xsl:if test="$bUseXPATHExpression">	
											<xsl:text disable-output-escaping="yes">bpws:getVariableData("scenarioTriggeringConditionVar", "value") = "</xsl:text><xsl:value-of select="concat(./../../../../@name, @verb)" /><xsl:text disable-output-escaping="yes">"</xsl:text>
										</xsl:if>
										<xsl:if test="not($bUseXPATHExpression)">																								
											<xsl:text disable-output-escaping="yes">"</xsl:text><xsl:value-of select="concat(./../../../../@name, @verb)" /><xsl:text disable-output-escaping="yes">".compareTo(scenarioTriggeringConditionVar) == 0</xsl:text>	
										</xsl:if>
									</xsl:attribute>

									<xsl:element name="reply">

										<xsl:attribute name="partner">
											<xsl:value-of select="./../../../../@name" />
										</xsl:attribute>
										<xsl:attribute name="portType">
											<xsl:value-of select="concat('wsdlWBI:', ./../../@name)" />
										</xsl:attribute>
										<xsl:attribute name="operation">
											<xsl:value-of select="@verb" />
										</xsl:attribute>
										<xsl:attribute name="variable">
											<xsl:value-of select="'currentException'" />
										</xsl:attribute>
									</xsl:element>
								</xsl:element>
							</xsl:for-each>
						</xsl:element>
					</xsl:when>
					<xsl:otherwise>
						<xsl:element name="empty">
						</xsl:element>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:element>
		</xsl:element>
	</xsl:template>


	<xsl:template name="writeScenarios">	

		<xsl:if test="count(document($pdProcess)/*/Scenarios/Scenario) = 0">
			<xsl:message terminate="yes">
				<xsl:value-of select="'Invalid template. It do not have any scenarios'" />
			</xsl:message>
		</xsl:if>
						
		<xsl:element name="flow">
			<xsl:attribute name="name">
				<xsl:value-of select="'dispatcherFlow'" />						
			</xsl:attribute>


			<xsl:element name="links">
				<xsl:for-each select="document($pdProcess)/*/Scenarios/Scenario">
					<xsl:variable name="strScenarioName" select="normalize-space(@Name)" />
					<xsl:for-each select="document($wsdlServiceInfo)/*/tempServiceLinkType[*]/IsRequestResponse/tempPortType[*]/tempScenarios/tempScenarioInfo[@name = $strScenarioName]">
						<xsl:element name="link">
							<xsl:attribute name="name">
								<xsl:value-of select="concat('dispatcherFlowTo', $strScenarioName, position())" />
							</xsl:attribute>
						</xsl:element>
					</xsl:for-each>					
				</xsl:for-each>

				<xsl:element name="link">
					<xsl:attribute name="name">
						<xsl:value-of select="'intializerToDispatcher'" />
					</xsl:attribute>
				</xsl:element> 
			</xsl:element>

			<xsl:element name="assign">
				<xsl:element name="copy">
					<xsl:element name="from">
						<xsl:attribute name="expression">
						<xsl:if test="$bUseXPATHExpression">	
							<xsl:value-of select="''" />
						</xsl:if>
						<xsl:if test="not($bUseXPATHExpression)">	
							<xsl:text disable-output-escaping="yes">""</xsl:text>							
						</xsl:if>
						</xsl:attribute>																	
					</xsl:element>
					<xsl:element name="to">
						<xsl:attribute name="variable">
							<xsl:value-of select="'scenarioTriggeringConditionVar'" />
						</xsl:attribute>							
						<xsl:attribute name="part">
							<xsl:value-of select="'value'" />
						</xsl:attribute>							
					</xsl:element>
				</xsl:element>

				<xsl:element name="source">
					<xsl:attribute name="linkname">
						<xsl:value-of select="'intializerToDispatcher'" />
					</xsl:attribute>
				</xsl:element>
			</xsl:element>


			<xsl:element name="pick">
				<xsl:attribute name="createInstance">
					<xsl:value-of select="'yes'" />						
				</xsl:attribute>

				<xsl:for-each select="document($pdProcess)/*/Scenarios/Scenario">
					<xsl:variable name="strScenarioName" select="normalize-space(@Name)" />

				
					<xsl:variable name="strCorrelationSetName">
						<xsl:if test="pd.nodes/InitialNode/CorrelationSet[@IsInit = 'Yes'] and  count(document($pdProcess)/*/CorrelationSets/CorrelationSet) &gt; 0">
							<xsl:variable name="strProperties" select="pd.nodes/InitialNode/CorrelationSet[@IsInit = 'Yes']/@pd.correlation.properties" />
							<xsl:value-of select="document($pdProcess)/*/CorrelationSets/CorrelationSet[@pd.properties = $strProperties]/@pd.name" />
						</xsl:if>
					 </xsl:variable>


					<xsl:for-each select="document($wsdlServiceInfo)/*/tempServiceLinkType[*]/IsRequestResponse/tempPortType[*]/tempScenarios/tempScenarioInfo[@name = $strScenarioName]">					
						<xsl:element name="onMessage">
							<xsl:attribute name="partner">
								<xsl:value-of select="./../../../../@name" />
							</xsl:attribute>
							<xsl:attribute name="portType">
								<xsl:value-of select="concat('wsdlWBI:', ./../../@name)" />
							</xsl:attribute>
							<xsl:attribute name="operation">
								<xsl:value-of select="./@verb" />
							</xsl:attribute>
							<xsl:attribute name="variable">
								<xsl:value-of select="./../../../@variable" />
							</xsl:attribute>

							<xsl:call-template name="writeCorrelations">
								<xsl:with-param name="strSet" select="$strCorrelationSetName"/>
								<xsl:with-param name="strInitiate" select="'yes'" />								
							</xsl:call-template>							

							<!-- *** write assignment to the triggering variable *** -->
							<xsl:element name="assign">
								<xsl:element name="copy">
									<xsl:element name="from">
										<xsl:attribute name="expression">
										<xsl:if test="$bUseXPATHExpression">	
											<xsl:value-of select="concat(./../../../../@name, ./@verb)" />
										</xsl:if>
										<xsl:if test="not($bUseXPATHExpression)">	
											<xsl:text disable-output-escaping="yes">"</xsl:text><xsl:value-of select="concat(./../../../../@name, ./@verb)" /><xsl:text disable-output-escaping="yes">"</xsl:text>							
										</xsl:if>											
										</xsl:attribute>																	
									</xsl:element>
									<xsl:element name="to">
										<xsl:attribute name="variable">
											<xsl:value-of select="'scenarioTriggeringConditionVar'" />
										</xsl:attribute>							
										<xsl:attribute name="part">
											<xsl:value-of select="'value'" />
										</xsl:attribute>							
									</xsl:element>
								</xsl:element>
							</xsl:element>
						</xsl:element>						
					</xsl:for-each>
				</xsl:for-each>

				<xsl:element name="target">
					<xsl:attribute name="linkname">
						<xsl:value-of select="'intializerToDispatcher'" />
					</xsl:attribute>
				</xsl:element>

				<xsl:for-each select="document($pdProcess)/*/Scenarios/Scenario">
					<xsl:variable name="strScenarioName" select="normalize-space(@Name)" />
					<xsl:for-each select="document($wsdlServiceInfo)/*/tempServiceLinkType[*]/IsRequestResponse/tempPortType[*]/tempScenarios/tempScenarioInfo[@name = $strScenarioName]">
						<xsl:element name="source">
							<xsl:attribute name="linkname">
								<xsl:value-of select="concat('dispatcherFlowTo', $strScenarioName, position())" />
							</xsl:attribute>
							<xsl:attribute name="transitionCondition">								
							<xsl:if test="$bUseXPATHExpression">	
								<xsl:text disable-output-escaping="yes">bpws:getVariableData('scenarioTriggeringConditionVar', 'value') = '</xsl:text><xsl:value-of select="concat(./../../../../@name, ./@verb)" /><xsl:text disable-output-escaping="yes">'</xsl:text>	
							</xsl:if>
							<xsl:if test="not($bUseXPATHExpression)">									
								<xsl:text disable-output-escaping="yes">"</xsl:text><xsl:value-of select="concat(./../../../../@name, ./@verb)" /><xsl:text disable-output-escaping="yes">".compareTo(scenarioTriggeringConditionVar) == 0</xsl:text>	
							</xsl:if>																			
							</xsl:attribute>
						</xsl:element>
					</xsl:for-each>					
				</xsl:for-each>

			</xsl:element>

			<xsl:for-each select="document($pdProcess)/*/Scenarios/Scenario">				
				<xsl:call-template name="writeScenario" />						
			</xsl:for-each>
		</xsl:element>
	</xsl:template>


	<xsl:template name="writeScenario">							

		<xsl:element name="flow">	
			<xsl:attribute name="name">
				<xsl:value-of select="normalize-space(@Name)" />						
			</xsl:attribute>
			
			<xsl:call-template name="writeLinks" />

			<!-- if start does not exist, or more than one start node exists, then throw an error. -->
			<xsl:if test="not(count(pd.nodes/*[count(./pd.links/pd.targets/pd.link) = 0 and name(.) = 'InitialNode']) = 1)">
				<xsl:message terminate="yes">
					<xsl:value-of select="'Invalid scenario. Has none or more than one start node.'" />
				</xsl:message>				
			</xsl:if>						

			<!-- if there is any node which don't have any incoming link other than the start node that is also an error -->
			<xsl:if test="pd.nodes/*[count(./pd.links/pd.targets/pd.link) = 0 and not(name(.) = 'InitialNode')]">
				<xsl:message terminate="yes">
					<xsl:value-of select="'Invalid scenario. Has one or more non-standard start node(s).'" />
				</xsl:message>				
			</xsl:if>
						
			<!-- if there is any node which don't have any outgoing link other than the success end, failure end,break and service call types that is also an error -->
			<xsl:if test="pd.nodes/*[count(./pd.links/pd.sources/pd.link) = 0 and (name(.) = 'InitialNode' or name(.) = 'ActionNode' or name(.) = 'SubDiagramNode' or name(.) = 'IteratorNode')]">
				<xsl:message terminate="yes">
					<xsl:value-of select="'Invalid scenario. Has one or more non-standard end node(s).'" />
				</xsl:message>				
			</xsl:if>

			<xsl:for-each select="pd.nodes/*">
				<xsl:choose>
					<xsl:when test="count(./pd.links/pd.sources/pd.link[@type = 'ExceptionLink']) &gt; 0 or (name(.) = 'IteratorNode' and count(pd.nodes/*[name(.) = 'BreakNode']) &gt; 0)">
						<xsl:call-template name="writeNodeWithScope">				
							<xsl:with-param name="strScenarioName" select="normalize-space(./../../@Name)" />			
						</xsl:call-template>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="writeNode">				
							<xsl:with-param name="strScenarioName" select="normalize-space(./../../@Name)" />			
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:for-each>

			<xsl:variable name="strScenarioName" select="normalize-space(@Name)" />			
			<xsl:for-each select="document($wsdlServiceInfo)/*/tempServiceLinkType[*]/IsRequestResponse/tempPortType[*]/tempScenarios/tempScenarioInfo[@name = $strScenarioName]">
				<xsl:element name="target">
					<xsl:attribute name="linkname">
						<xsl:value-of select="concat('dispatcherFlowTo', $strScenarioName, position())" />
					</xsl:attribute>
				</xsl:element>
			</xsl:for-each>					
	
		</xsl:element>
	</xsl:template>

	<xsl:template name="writeNode">
	<xsl:param name="strScenarioName" select="''" />
	<xsl:param name="strIteratorLabel" select="''" />
	<xsl:param name="bFromScenarioDiagram" select="1" />			

		<xsl:choose>
			<xsl:when test="name(.)='InitialNode'">
				<xsl:call-template name="writeInitialNode" >
					<xsl:with-param name="strIteratorLabel" select="$strIteratorLabel" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="name(.)='ActionNode'">
				<xsl:call-template name="writeActionWithServiceNode">
					<xsl:with-param name="strScenarioName" select="$strScenarioName" />				
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="name(.)='SuccessEndNode'">
				<xsl:call-template name="writeSuccessEndNode">
					<xsl:with-param name="strScenarioName" select="$strScenarioName" />	
					<xsl:with-param name="strIteratorLabel" select="$strIteratorLabel" />			
					<xsl:with-param name="bFromScenarioDiagram" select="$bFromScenarioDiagram" />			
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="name(.)='FailureEndNode'">
				<xsl:call-template name="writeFailureEndNode" >
					<xsl:with-param name="strIteratorLabel" select="$strIteratorLabel" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="name(.)='IteratorNode'">
				<xsl:call-template name="writeIteratorNode">
					<xsl:with-param name="strScenarioName" select="$strScenarioName" />				
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="name(.)='SubDiagramNode'">
				<xsl:call-template name="writeSubDiagramNode">
					<xsl:with-param name="strScenarioName" select="$strScenarioName" />				
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="name(.)='BreakNode'">
				<xsl:call-template name="writeBreakNode" />
			</xsl:when>
		</xsl:choose>
	</xsl:template>

	<xsl:template name="writeNodeWithScope">
	<xsl:param name="strScenarioName" select="''" />
	<xsl:param name="strIteratorLabel" select="''" />

		<xsl:if test="not(name(.) = 'OutboundServiceNode') and not(name(.) = 'InboundServiceNode')">

			<xsl:if test="name(.) = 'IteratorNode'">
				<xsl:call-template name="writeIteratorConditionInit" />
			</xsl:if>
			
			<xsl:element name="scope">
				
				<xsl:element name="faultHandlers">

					<xsl:if test="count(./pd.links/pd.sources/pd.link[@type = 'ExceptionLink']) &gt; 0 ">
						<xsl:element name="catch">
							<xsl:attribute name="faultVariable">
								<xsl:value-of select="'currentException'" />
							</xsl:attribute>

							<xsl:choose>
								<xsl:when test="count(./pd.links/pd.sources/pd.link[@type = 'ExceptionLink']) = 1 and count(./pd.links/pd.sources/pd.link[@type = 'ExceptionLink' and normalize-space(pd.condition) = 'AnyException']) = 1">
									<xsl:call-template name="writeFaultHandlerConditionInit">
										<xsl:with-param name="strCondition" select="'AnyException'" />
										<xsl:with-param name="bIsString" select="1" />
									</xsl:call-template>
								</xsl:when>
								<xsl:when test="count(./pd.links/pd.sources/pd.link[@type = 'ExceptionLink' and not(normalize-space(pd.condition) = 'AnyException')]) &gt; 0">
									<xsl:element name="switch">
										<xsl:for-each select="./pd.links/pd.sources/pd.link[@type = 'ExceptionLink' and not(normalize-space(pd.condition) = 'AnyException')]">
											<xsl:element name="case">
												<xsl:attribute name="condition">
												<xsl:if test="$bUseXPATHExpression">	
													<xsl:text disable-output-escaping="yes">bpws:getVariableData('currentException', 'genericFault', '/type') = '</xsl:text><xsl:value-of select="normalize-space(pd.condition)" /><xsl:text disable-output-escaping="yes">'</xsl:text>	
												</xsl:if>
												<xsl:if test="not($bUseXPATHExpression)">														
													<xsl:text disable-output-escaping="yes">"</xsl:text><xsl:value-of select="normalize-space(pd.condition)" /><xsl:text disable-output-escaping="yes">".compareTo(currentException.getType()) == 0</xsl:text>	
												</xsl:if>																															
												</xsl:attribute>

												<xsl:call-template name="writeFaultHandlerConditionInit">
													<xsl:with-param name="strCondition" select="normalize-space(pd.condition)" />
												</xsl:call-template>

											</xsl:element>
										</xsl:for-each>
										<xsl:element name="otherwise">
											<xsl:choose>
												<xsl:when test="./pd.links/pd.sources/pd.link[@type = 'ExceptionLink' and normalize-space(pd.condition) = 'AnyException']">
													<xsl:call-template name="writeFaultHandlerConditionInit">
														<xsl:with-param name="strCondition" select="'AnyException'" />
														<xsl:with-param name="bIsString" select="1" />
													</xsl:call-template>
												</xsl:when>
												<xsl:otherwise>
													<xsl:element name="throw">
														<xsl:attribute name="faultVariable">
															<xsl:value-of select="'currentException'" />
														</xsl:attribute>
													</xsl:element>										
												</xsl:otherwise>
											</xsl:choose>
										</xsl:element>							
									</xsl:element>
								</xsl:when>
							</xsl:choose>

						</xsl:element>
					</xsl:if>
					<xsl:if test="name(.) = 'IteratorNode' and count(pd.nodes/*[name(.) = 'BreakNode']) &gt; 0">
						<xsl:element name="catch">
							<xsl:attribute name="faultName">
								<xsl:value-of select="'tns:genericBreakFault'" />
							</xsl:attribute>

							<xsl:element name="empty">
								<xsl:attribute name="name">
									<xsl:value-of select="'emptyBreakHandlerNode'" />									
								</xsl:attribute>
							</xsl:element>
						</xsl:element>
					</xsl:if>				

				</xsl:element>
				<!--
				<xsl:call-template name="writeFaultHandlerConditionInit">
					<xsl:with-param name="strCondition" select="''" />
					<xsl:with-param name="bIsString" select="1" />
				</xsl:call-template>
				-->

				<xsl:choose>
					<xsl:when test="name(.)='InitialNode'">
						<!--  this is an invalid case for process templates -->						
						<xsl:choose>
							<xsl:when test="$strIteratorLabel = ''">
								<xsl:call-template name="writeInitialNode" >									
									<xsl:with-param name="bWriteNodeLinks" select="0" />						
								</xsl:call-template>
							</xsl:when>
							<xsl:otherwise>
								<xsl:element name="flow">
									<xsl:call-template name="writeInitialNode" >
										<xsl:with-param name="strIteratorLabel" select="$strIteratorLabel" />
										<xsl:with-param name="bWriteNodeLinks" select="0" />						
									</xsl:call-template>
								</xsl:element>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:when test="name(.)='ActionNode'">
						<xsl:call-template name="writeActionWithServiceNode">
							<xsl:with-param name="strScenarioName" select="$strScenarioName" />				
							<xsl:with-param name="bWriteNodeLinks" select="0" />						
						</xsl:call-template>
					</xsl:when>
					<xsl:when test="name(.)='IteratorNode'">
						<xsl:call-template name="writeIteratorNode">
							<xsl:with-param name="strScenarioName" select="$strScenarioName" />	
							<xsl:with-param name="bWriteNodeLinks" select="0" />						
						</xsl:call-template>
					</xsl:when>
					<xsl:when test="name(.)='SubDiagramNode'">
						<xsl:call-template name="writeSubDiagramNode">
							<xsl:with-param name="strScenarioName" select="$strScenarioName" />				
							<xsl:with-param name="bWriteNodeLinks" select="0" />						
						</xsl:call-template>
					</xsl:when>
				</xsl:choose>


				<xsl:choose>
					<xsl:when test="name(.) = 'IteratorNode'">						
						<xsl:variable name="strLabel">
							<xsl:call-template name="writeLabel" />
						</xsl:variable>

						<xsl:element name="target">
							<xsl:attribute name="linkName">
								<xsl:value-of select="concat('transitionLink_Initialize_', normalize-space($strLabel))" />
							</xsl:attribute>		
						</xsl:element>

						<xsl:choose>
							<xsl:when test="count(pd.links/pd.targets/pd.link[not(@type = 'ExceptionLink')]) &gt; 0">
								<xsl:call-template name="writeSourceNodeLinksInfoWithFaultHandling" />
							</xsl:when>
							<xsl:otherwise>
								<xsl:call-template name="writeSourceNodeLinksInfo" />
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:when test="count(pd.links/pd.targets/pd.link[not(@type = 'ExceptionLink')]) &gt; 0">
						<xsl:call-template name="writeNodeLinksInfoWithFaultHandling" />
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="writeNodeLinksInfo" />
					</xsl:otherwise>
				</xsl:choose>
			</xsl:element>
		</xsl:if>
	</xsl:template>


	<xsl:template name="writeFaultHandlerConditionInit">
	<xsl:param name="strCondition" />
	<xsl:param name="bIsString" select="0" />
		<xsl:element name="assign">
			<xsl:element name="copy">
				<xsl:element name="from">
					<xsl:attribute name="expression">
						<xsl:choose>
							<xsl:when test="not($bIsString)">
								<xsl:value-of select="$strCondition" />
							</xsl:when>
							<xsl:otherwise>
								<xsl:if test="$bUseXPATHExpression">	
									<xsl:value-of select="$strCondition" />
								</xsl:if>
								<xsl:if test="not($bUseXPATHExpression)">													
									<xsl:text disable-output-escaping="yes">"</xsl:text><xsl:value-of select="$strCondition" /><xsl:text disable-output-escaping="yes">"</xsl:text>	
								</xsl:if>								
							</xsl:otherwise>
						</xsl:choose>
					</xsl:attribute>																	
				</xsl:element>
				<xsl:element name="to">
					<xsl:attribute name="variable">
						<xsl:value-of select="'exceptionConditionVar'" />
					</xsl:attribute>							
					<xsl:attribute name="part">
						<xsl:value-of select="'value'" />
					</xsl:attribute>							
				</xsl:element>
			</xsl:element>
		</xsl:element>
	</xsl:template>

	<xsl:template name="writeInitialNode">
	<xsl:param name="strIteratorLabel" select="''" />
	<xsl:param name="bWriteNodeLinks" select="1" />
	
		<xsl:element name="empty">
			<xsl:attribute name="name">
				<xsl:call-template name="writeLabel" />
			</xsl:attribute>

			<xsl:call-template name="writeDescription">
				<xsl:with-param name="strDesc" select="pd.desc"/>
			</xsl:call-template>

			<xsl:choose>
				<xsl:when test="$bWriteNodeLinks and $strIteratorLabel = ''">
					<xsl:call-template name="writeNodeLinksInfo" />
				</xsl:when>
				<xsl:when test="$bWriteNodeLinks and not($strIteratorLabel = '')">
					<xsl:element name="target">
						<xsl:attribute name="linkName">
							<xsl:value-of select="concat('transitionLink__CurrentVar_', normalize-space($strIteratorLabel))" />
						</xsl:attribute>		
					</xsl:element>

					<xsl:if test="$bWriteNodeLinks">
						<xsl:call-template name="writeSourceNodeLinksInfo" />
					</xsl:if>					
				</xsl:when>
				<xsl:when test="not($strIteratorLabel = '')">
					<!--  this is an invalid case for process templates -->
						<xsl:element name="target">
							<xsl:attribute name="linkName">
								<xsl:value-of select="concat('transitionLink__CurrentVar_', normalize-space($strIteratorLabel))" />
							</xsl:attribute>		
						</xsl:element>
						<xsl:element name="source">
							<xsl:attribute name="linkName">
								<xsl:value-of select="concat('transitionLink_Increment_', normalize-space($strIteratorLabel))" />
							</xsl:attribute>		
						</xsl:element>
				</xsl:when>
			</xsl:choose>

		</xsl:element>
	</xsl:template>

	<xsl:template name="writeActionWithServiceNode">
	<xsl:param name="strScenarioName" />				
	<xsl:param name="bWriteNodeLinks" select="1" />
		<!-- if an action node has meesage link then we are going to have the action node and the service node as a sequence -->
		<xsl:choose>
			<xsl:when test="count(pd.links/pd.sources/pd.link[@type = 'MessageLink']) &gt; 0 and not($bWriteNodeLinks)">
				<xsl:element name="flow">					
					<xsl:call-template name="writeActionNode">
						<xsl:with-param name="bWriteSourceMessageLinksOnly" select="1" />						
					</xsl:call-template>

					<xsl:for-each select="pd.links/pd.sources/pd.link[@type = 'MessageLink']">
						<xsl:variable name="strUniqueID" select="@pd.id" />
						<xsl:for-each select="./../../../../*[pd.links/pd.targets/pd.link[@pd.id = $strUniqueID]]">
							<xsl:choose>
								<xsl:when test="name(.)='OutboundServiceNode'">
									<xsl:choose>
										<xsl:when test="not(pd.service.isSync = 'true')">
											<xsl:call-template name="writeASyncOutboundServiceNode" >
												<xsl:with-param name="bWriteTargetMessageLinksOnly" select="1" />						
												<xsl:with-param name="strScenarioName" select="$strScenarioName"/>				
											</xsl:call-template>
										</xsl:when>
										<xsl:otherwise>
											<xsl:call-template name="writeSyncOutboundServiceNode" >
												<xsl:with-param name="bWriteTargetMessageLinksOnly" select="1" />						
												<xsl:with-param name="strScenarioName" select="$strScenarioName"/>				
											</xsl:call-template>
										</xsl:otherwise>
									</xsl:choose>
								</xsl:when>
								<xsl:when test="name(.)='InboundServiceNode'">
									<xsl:call-template name="writeInboundServiceNode" >
										<xsl:with-param name="bWriteTargetMessageLinksOnly" select="1" />						
									</xsl:call-template>
								</xsl:when>
							</xsl:choose>
						</xsl:for-each>
					</xsl:for-each>
				</xsl:element>
			</xsl:when>
			<xsl:when test="count(pd.links/pd.sources/pd.link[@type = 'MessageLink']) &gt; 0">
				<xsl:call-template name="writeActionNode">
					<xsl:with-param name="bWriteSourceMessageLinksOnly" select="1" />						
					<xsl:with-param name="bWriteNodeLinks" select="$bWriteNodeLinks" />						
				</xsl:call-template>

				<xsl:for-each select="pd.links/pd.sources/pd.link[@type = 'MessageLink']">
					<xsl:variable name="strUniqueID" select="@pd.id" />
					<xsl:for-each select="./../../../../*[pd.links/pd.targets/pd.link[@pd.id = $strUniqueID]]">
						<xsl:choose>
							<xsl:when test="name(.)='OutboundServiceNode'">
								<xsl:choose>
									<xsl:when test="not(pd.service.isSync = 'true')">
										<xsl:call-template name="writeASyncOutboundServiceNode" >
											<xsl:with-param name="bWriteTargetMessageLinksOnly" select="1" />						
											<xsl:with-param name="bWriteNodeLinks" select="$bWriteNodeLinks" />						
											<xsl:with-param name="strScenarioName" select="$strScenarioName"/>				
										</xsl:call-template>
									</xsl:when>
									<xsl:otherwise>
										<xsl:call-template name="writeSyncOutboundServiceNode" >
											<xsl:with-param name="bWriteTargetMessageLinksOnly" select="1" />						
											<xsl:with-param name="bWriteNodeLinks" select="$bWriteNodeLinks" />						
											<xsl:with-param name="strScenarioName" select="$strScenarioName"/>				
										</xsl:call-template>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:when>
							<xsl:when test="name(.)='InboundServiceNode'">
								<xsl:call-template name="writeInboundServiceNode" >
									<xsl:with-param name="bWriteTargetMessageLinksOnly" select="1" />						
									<xsl:with-param name="bWriteNodeLinks" select="$bWriteNodeLinks" />						
								</xsl:call-template>
							</xsl:when>
						</xsl:choose>
					</xsl:for-each>
				</xsl:for-each>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="writeActionNode">
					<xsl:with-param name="bWriteNodeLinks" select="$bWriteNodeLinks" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>	
	</xsl:template>

	<xsl:template name="writeActionNode">
	<xsl:param name="bWriteSourceMessageLinksOnly" select="0" />
	<xsl:param name="bWriteNodeLinks" select="0" />
		<xsl:text disable-output-escaping="yes">&lt;wpc:script name="</xsl:text><xsl:call-template name="writeLabel" /><xsl:text disable-output-escaping="yes">"></xsl:text>
			<xsl:value-of select="$newline" />
						
			<xsl:text disable-output-escaping="yes">&lt;wpc:code language="</xsl:text>
				<xsl:value-of select="pd.codefragment/@pd.type" /><xsl:text disable-output-escaping="yes">"></xsl:text>		
				<xsl:value-of select="pd.codefragment" /> 
			<xsl:text disable-output-escaping="yes">
				&lt;/wpc:code>
			</xsl:text>

			<xsl:call-template name="writeDescription">
				<xsl:with-param name="strDesc" select="pd.desc"/>
			</xsl:call-template>					
					
			<xsl:choose>											
				<xsl:when test="$bWriteNodeLinks">
					<xsl:call-template name="writeNodeLinksInfo" >
						<xsl:with-param name="bWriteSourceMessageLinksOnly" select="$bWriteSourceMessageLinksOnly" />
					</xsl:call-template>
				</xsl:when>
				<xsl:when test="$bWriteSourceMessageLinksOnly">
					<xsl:for-each select="pd.links/pd.sources/pd.link[@type = 'MessageLink']">
						<xsl:element name="source">
							<xsl:attribute name="linkName">
								<xsl:call-template name="writeLabel">
									<xsl:with-param name="strStdLabel" select="'transitionLink'"/>
								</xsl:call-template>
							</xsl:attribute>		
						</xsl:element>
					</xsl:for-each>				
				</xsl:when>
			</xsl:choose>

		<xsl:text disable-output-escaping="yes">
			&lt;/wpc:script>
		</xsl:text>
	</xsl:template>

	<xsl:template name="writeSyncOutboundServiceNode">
	<xsl:param name="strScenarioName" />
	<xsl:param name="bWriteTargetMessageLinksOnly" select="0" />										
	<xsl:param name="bWriteNodeLinks" select="0" />
		<xsl:variable name="strUniqueID" select="./@pd.id" />

		<xsl:variable name="strPortName" select="./pd.port" />
		<xsl:variable name="strVerb" select="./pd.verb" />
		<xsl:variable name="strPortType" select="document($wsdlServiceInfo)/*/tempServiceLinkType[@name = $strPortName]/IsSolicitResponse/tempPortType[tempServiceNodes/tempServiceNode[@pd.id = $strUniqueID and @pd.verb = $strVerb]]/@name" />
		<xsl:variable name="strBusObjVariable">
			<xsl:choose>
				<xsl:when test="pd.busobjvariable = ''">
					<xsl:value-of select="concat(normalize-space($strPortName), 'BusObj')" />
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="pd.busobjvariable" />
				</xsl:otherwise>
			</xsl:choose>			
		</xsl:variable>

		<xsl:variable name="strCompPortName" select="./pd.comp.port" />
		<xsl:variable name="strCompVerb" select="./pd.comp.verb" />										
		<xsl:variable name="strCompPortType" select="document($wsdlServiceInfo)/*/tempServiceLinkType[@name = $strCompPortName]/IsSolicitResponse/tempPortType[tempServiceNodes/tempServiceNode[@pd.id = $strUniqueID and @pd.comp.verb = $strCompVerb]]/@name" />
		<xsl:variable name="strCompBusObjVariable">
			<xsl:choose>
				<xsl:when test="pd.comp.busobjvariable = ''">
					<xsl:value-of select="concat(normalize-space($strCompPortName), 'BusObj')" />
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="pd.comp.busobjvariable" />
				</xsl:otherwise>
			</xsl:choose>			
		</xsl:variable>
		
		<xsl:variable name="strLabel">
			<xsl:call-template name="writeLabel" />
		</xsl:variable>

		<xsl:variable name="strCorrelationSetName">
			<xsl:if test="./CorrelationSet and count(document($pdProcess)/*/CorrelationSets/CorrelationSet) &gt; 0">
				<xsl:variable name="strProperties" select="./CorrelationSet/@pd.correlation.properties" />
				<xsl:value-of select="document($pdProcess)/*/CorrelationSets/CorrelationSet[@pd.properties = $strProperties]/@pd.name" />
			</xsl:if>
		 </xsl:variable>
		<xsl:variable name="strInitCorrelationSet">
			<xsl:choose>
				<xsl:when test="./CorrelationSet/@IsInit = 'Yes'">
					<xsl:value-of select="'yes'" />
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="'no'" />
				</xsl:otherwise>			
			</xsl:choose>
		 </xsl:variable>

		 <xsl:variable name="strTimeOutExpression">
			<xsl:choose>
				<xsl:when test="pd.wait.timeout/@pd.type = 'Constant'">
					<xsl:value-of select="pd.wait.timeout" />
				</xsl:when>
				<xsl:when test="pd.wait.timeout/@pd.type = 'Variable'">
					<xsl:value-of select="pd.wait.timeout" />
				</xsl:when>
				<xsl:when test="pd.wait.timeout/@pd.type = 'Parameter'">
					<xsl:text disable-output-escaping="yes">getConfigProperty("</xsl:text><xsl:value-of select="normalize-space(pd.wait.timeout)" /><xsl:text disable-output-escaping="yes">")</xsl:text>	
				</xsl:when>
				<xsl:otherwise>					
				</xsl:otherwise>
			</xsl:choose>
		 </xsl:variable>


		<xsl:choose>
			<xsl:when test="($strBusObjVariable = 'triggeringBusObj') and count(xalan:distinct(document($wsdlServiceInfo)/*/tempServiceLinkType/IsRequestResponse[@type = 'Yes']/@variable)) &gt; 1">			
				<!-- If one of the triggering Business object is not of the same BO type as the port type for this scenario , then that is an error in design-->
				<xsl:variable name="strPortName" select="./pd.port" />
				<xsl:variable name="strPortBOType" select="document($wsdlServiceInfo)/*/tempServiceLinkType[@name = $strPortName]/@BusObjType" />
				<xsl:if test="count(document($wsdlServiceInfo)/*/tempServiceLinkType[IsRequestResponse/tempPortType[*]/tempScenarios/tempScenarioInfo[@name= $strScenarioName and @BusObjType = $strPortBOType]]) &gt; 0">
					<xsl:message terminate="yes">
						<xsl:value-of select="'Invalid template. One of the scenario has the triggering Business Object whose data type does not match the data type of a Service Port(s).'" />
					</xsl:message>					
				</xsl:if>
				<xsl:element name="switch">
					<xsl:for-each select="xalan:distinct(document($wsdlServiceInfo)/*/tempServiceLinkType[IsRequestResponse/tempPortType[*]/tempScenarios/tempScenarioInfo[@name= $strScenarioName]])">
						<xsl:element name="case">
							<xsl:attribute name="condition">
								<xsl:for-each select="IsRequestResponse/tempPortType[*]/tempScenarios/tempScenarioInfo[@name = $strScenarioName]">								
									<xsl:if test="position() = 1">
										<xsl:if test="$bUseXPATHExpression">	
											<xsl:text disable-output-escaping="yes">bpws:getVariableData('scenarioTriggeringConditionVar', 'value') = '</xsl:text><xsl:value-of select="concat(./../../../../@name, @verb)" /><xsl:text disable-output-escaping="yes">'</xsl:text>	
										</xsl:if>
										<xsl:if test="not($bUseXPATHExpression)">
											<xsl:text disable-output-escaping="yes">"</xsl:text><xsl:value-of select="concat(./../../../../@name, @verb)" /><xsl:text disable-output-escaping="yes">".compareTo(scenarioTriggeringConditionVar) == 0</xsl:text>																									
										</xsl:if>																		
									</xsl:if>
									<xsl:if test="position() != 1">										
										<xsl:if test="$bUseXPATHExpression">	
											<xsl:text disable-output-escaping="yes"> or bpws:getVariableData('scenarioTriggeringConditionVar', 'value') = '</xsl:text><xsl:value-of select="concat(./../../../../@name, @verb)" /><xsl:text disable-output-escaping="yes">'</xsl:text>	
										</xsl:if>
										<xsl:if test="not($bUseXPATHExpression)">																								
											<xsl:text disable-output-escaping="yes"> || "</xsl:text><xsl:value-of select="concat(./../../../../@name, @verb)" /><xsl:text disable-output-escaping="yes">".compareTo(scenarioTriggeringConditionVar) == 0</xsl:text>																									
										</xsl:if>																		
									</xsl:if>
								</xsl:for-each>
							</xsl:attribute>

							<xsl:call-template name="writeInvokeActivity">
								<xsl:with-param name="strLabel" select="$strLabel" />
								<xsl:with-param name="strPartner" select="$strPortName" />
								<xsl:with-param name="strPortType" select="$strPortType" />								
								<xsl:with-param name="strOperation" select="$strVerb" />								
								<xsl:with-param name="strInputVariable" select="./IsRequestResponse/@variable" />
								<xsl:with-param name="strOutputVariable" select="./IsRequestResponse/@variable" />
								<xsl:with-param name="strCompPortName" select="$strCompPortName" />
								<xsl:with-param name="strCompPortType" select="$strCompPortType" />
								<xsl:with-param name="strCompVerb" select="$strCompVerb" />										
								<xsl:with-param name="strCompBusObjVariable" select="$strCompBusObjVariable" />
								<xsl:with-param name="strTimeOutExpression" select="$strTimeOutExpression" />
								<xsl:with-param name="strCorrelationSetName" select="$strCorrelationSetName" />																		
								<xsl:with-param name="strInitCorrelationSet" select="$strInitCorrelationSet" />
								<xsl:with-param name="strPattern" select="'out'" />

								<xsl:with-param name="strScenarioName" select="$strScenarioName" />																																				
							</xsl:call-template>							

							<xsl:choose>											
								<xsl:when test="$bWriteNodeLinks">
									<xsl:call-template name="writeNodeLinksInfo" >
										<xsl:with-param name="bWriteTargetMessageLinksOnly" select="$bWriteTargetMessageLinksOnly" />
									</xsl:call-template>
								</xsl:when>
								<xsl:when test="$bWriteTargetMessageLinksOnly">
									<xsl:for-each select="pd.links/pd.targets/pd.link[@type = 'MessageLink']">
										<xsl:element name="target">
											<xsl:attribute name="linkName">					
												<xsl:call-template name="writeLabel">
													<xsl:with-param name="strStdLabel" select="'transitionLink'"/>
												</xsl:call-template>
											</xsl:attribute>				
										</xsl:element>
									</xsl:for-each>
								</xsl:when>
							</xsl:choose>


						</xsl:element>
					</xsl:for-each>
				</xsl:element>
			</xsl:when>			
			<xsl:otherwise>
				<xsl:call-template name="writeInvokeActivity">
					<xsl:with-param name="strLabel" select="$strLabel" />
					<xsl:with-param name="strPartner" select="$strPortName" />
					<xsl:with-param name="strPortType" select="$strPortType" />								
					<xsl:with-param name="strOperation" select="$strVerb" />								
					<xsl:with-param name="strInputVariable" select="$strBusObjVariable" />
					<xsl:with-param name="strOutputVariable" select="$strBusObjVariable" />
					<xsl:with-param name="strCompPortName" select="$strCompPortName" />
					<xsl:with-param name="strCompPortType" select="$strCompPortType" />
					<xsl:with-param name="strCompVerb" select="$strCompVerb" />										
					<xsl:with-param name="strCompBusObjVariable" select="$strCompBusObjVariable" />																		
					<xsl:with-param name="strTimeOutExpression" select="$strTimeOutExpression" />
					<xsl:with-param name="strCorrelationSetName" select="$strCorrelationSetName" />																		
					<xsl:with-param name="strInitCorrelationSet" select="$strInitCorrelationSet" />
					<xsl:with-param name="strPattern" select="'out'" />
					<xsl:with-param name="strScenarioName" select="$strScenarioName" />																																				
					<xsl:with-param name="bWriteTargetMessageLinksOnly" select="$bWriteTargetMessageLinksOnly" />														
					<xsl:with-param name="bWriteNodeLinks" select="$bWriteNodeLinks" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template name="writeInvokeActivity">
	<xsl:param name="strLabel" />
	<xsl:param name="strPartner" />
	<xsl:param name="strPortType" />
	<xsl:param name="strOperation" />	
	<xsl:param name="strInputVariable" />
	<xsl:param name="strOutputVariable" select="''"/>
	<xsl:param name="strCompPortName" select="''" />
	<xsl:param name="strCompPortType" select="''"/>		
	<xsl:param name="strCompVerb" select="''" />										
	<xsl:param name="strCompBusObjVariable" select="''" />
	<xsl:param name="strTimeOutExpression" select="''" />																		
	<xsl:param name="strCorrelationSetName" select="''" />																		
	<xsl:param name="strInitCorrelationSet" select="''" />
	<xsl:param name="strPattern" select="''" />
	<xsl:param name="strScenarioName" select="''" />
	<xsl:param name="bWriteTargetMessageLinksOnly" select="0" />														
	<xsl:param name="bWriteNodeLinks" select="0" />
																																					

		<xsl:element name="invoke">
			<xsl:attribute name="name">
				<xsl:value-of select="$strLabel" />
			</xsl:attribute>

			<xsl:attribute name="partner">
				<xsl:value-of select="$strPartner" />
			</xsl:attribute>
			<xsl:attribute name="portType">
				<xsl:value-of select="concat('wsdlWBI:', $strPortType)" />
			</xsl:attribute>
			<xsl:attribute name="operation">
				<xsl:value-of select="$strOperation" />
			</xsl:attribute>
			<xsl:attribute name="inputVariable">
				<xsl:value-of select="$strInputVariable" />
			</xsl:attribute>
			<xsl:if test="not($strOutputVariable = '')">
				<xsl:attribute name="outputVariable">
					<xsl:value-of select="$strOutputVariable">
				</xsl:value-of></xsl:attribute>
			</xsl:if>

			<xsl:if test="not($strTimeOutExpression = '')">
				<xsl:text disable-output-escaping="yes">&lt;wpc:expiration after='</xsl:text>	
					<xsl:value-of select="normalize-space($strTimeOutExpression)" />
				<xsl:text disable-output-escaping="yes">' /></xsl:text>					
			</xsl:if>

			<xsl:call-template name="writeCorrelations">
				<xsl:with-param name="strSet" select="$strCorrelationSetName"/>
				<xsl:with-param name="strInitiate" select="$strInitCorrelationSet" />								
				<xsl:with-param name="strPattern" select="$strPattern" />								
			</xsl:call-template>							


			<xsl:if test="not($strCompPortName = '')">

				<xsl:element name="compensationHandler">
					<xsl:choose>
						<xsl:when test="($strCompBusObjVariable = 'triggeringBusObj') and count(xalan:distinct(document($wsdlServiceInfo)/*/tempServiceLinkType/IsRequestResponse[@type = 'Yes']/@variable)) &gt; 1">			
							<!-- If one of the triggering Business object is not of the same BO type as the port type for this scenario , then that is an error in design-->
							<xsl:variable name="strPortBOType" select="document($wsdlServiceInfo)/*/tempServiceLinkType[@name = $strCompPortName]/@BusObjType" />
							<xsl:if test="count(document($wsdlServiceInfo)/*/tempServiceLinkType[IsRequestResponse/tempPortType[*]/tempScenarios/tempScenarioInfo[@name= $strScenarioName]]/@BusObjType = $strPortBOType) &gt; 0">
								<xsl:message terminate="yes">
									<xsl:value-of select="'Invalid template. One of the scenario has the triggering Business Object whose data type does not match the data type of a Service Port(s).'" />
								</xsl:message>					
							</xsl:if>
							<xsl:element name="switch">
								<xsl:for-each select="xalan:distinct(document($wsdlServiceInfo)/*/tempServiceLinkType[IsRequestResponse/tempPortType[*]/tempScenarios/tempScenarioInfo[@name= $strScenarioName]])">
									<xsl:element name="case">
										<xsl:attribute name="condition">
											<xsl:for-each select="IsRequestResponse/tempPortType[*]/tempScenarios/tempScenarioInfo[@name = $strScenarioName]">								
												<xsl:if test="position() = 1">
													<xsl:if test="$bUseXPATHExpression">	
														<xsl:text disable-output-escaping="yes">bpws:getVariableData('scenarioTriggeringConditionVar', 'value') = '</xsl:text><xsl:value-of select="concat(./../../../../@name, @verb)" /><xsl:text disable-output-escaping="yes">'</xsl:text>	
													</xsl:if>
													<xsl:if test="not($bUseXPATHExpression)">													
														<xsl:text disable-output-escaping="yes">"</xsl:text><xsl:value-of select="concat(./../../../../@name, @verb)" /><xsl:text disable-output-escaping="yes">".compareTo(scenarioTriggeringConditionVar) == 0</xsl:text>
													</xsl:if>																															
												</xsl:if>
												<xsl:if test="position() != 1">
													<xsl:if test="$bUseXPATHExpression">	
														<xsl:text disable-output-escaping="yes"> or bpws:getVariableData('scenarioTriggeringConditionVar', 'value') = '</xsl:text><xsl:value-of select="concat(./../../../../@name, @verb)" /><xsl:text disable-output-escaping="yes">'</xsl:text>	
													</xsl:if>
													<xsl:if test="not($bUseXPATHExpression)">																											
														<xsl:text disable-output-escaping="yes"> || "</xsl:text><xsl:value-of select="concat(./../../../../@name, @verb)" /><xsl:text disable-output-escaping="yes">".compareTo(scenarioTriggeringConditionVar) == 0</xsl:text>
													</xsl:if>																																												
												</xsl:if>
											</xsl:for-each>
										</xsl:attribute>

										<xsl:variable name="strCompOutputVariable">
											<xsl:if test="not($strOutputVariable = '')">
												<xsl:value-of select="./IsRequestResponse/@variable" />
											</xsl:if>
										</xsl:variable>

										<xsl:call-template name="writeInvokeActivity">
											<xsl:with-param name="strLabel" select="concat($strLabel, '_Compensation')" />
											<xsl:with-param name="strPartner" select="$strCompPortName" />
											<xsl:with-param name="strPortType" select="$strCompPortType" />								
											<xsl:with-param name="strOperation" select="$strCompVerb" />								
											<xsl:with-param name="strInputVariable" select="./IsRequestResponse/@variable" />
											<xsl:with-param name="strOutputVariable" select="$strCompOutputVariable" />
										</xsl:call-template>							
									</xsl:element>
								</xsl:for-each>
							</xsl:element>
						</xsl:when>			
						<xsl:otherwise>

							<xsl:variable name="strCompOutputVariable">
								<xsl:if test="not($strOutputVariable = '')">
									<xsl:value-of select="$strCompBusObjVariable" />
								</xsl:if>
							</xsl:variable>

							<xsl:call-template name="writeInvokeActivity">
								<xsl:with-param name="strLabel" select="concat($strLabel, '_Compensation')" />
								<xsl:with-param name="strPartner" select="$strCompPortName" />
								<xsl:with-param name="strPortType" select="$strCompPortType" />								
								<xsl:with-param name="strOperation" select="$strCompVerb" />								
								<xsl:with-param name="strInputVariable" select="$strCompBusObjVariable" />
								<xsl:with-param name="strOutputVariable" select="$strCompOutputVariable" />
							</xsl:call-template>

						</xsl:otherwise>
					</xsl:choose>
				</xsl:element>
			</xsl:if>

			<xsl:choose>											
				<xsl:when test="$bWriteNodeLinks">
					<xsl:call-template name="writeNodeLinksInfo" >
						<xsl:with-param name="bWriteTargetMessageLinksOnly" select="$bWriteTargetMessageLinksOnly" />
					</xsl:call-template>
				</xsl:when>
				<xsl:when test="$bWriteTargetMessageLinksOnly">
					<xsl:for-each select="pd.links/pd.targets/pd.link[@type = 'MessageLink']">
						<xsl:element name="target">
							<xsl:attribute name="linkName">					
								<xsl:call-template name="writeLabel">
									<xsl:with-param name="strStdLabel" select="'transitionLink'"/>
								</xsl:call-template>
							</xsl:attribute>				
						</xsl:element>
					</xsl:for-each>
				</xsl:when>
			</xsl:choose>

		</xsl:element> 
	</xsl:template>

	<xsl:template name="writeASyncOutboundServiceNode">
	<xsl:param name="strScenarioName" />				
	<xsl:param name="bWriteTargetMessageLinksOnly" select="0" />										
	<xsl:param name="bWriteNodeLinks" select="0" />
		<xsl:variable name="strUniqueID" select="./@pd.id" />

		<xsl:variable name="strPortName" select="./pd.port" />
		<xsl:variable name="strVerb" select="./pd.verb" />
		<xsl:variable name="strPortType" select="document($wsdlServiceInfo)/*/tempServiceLinkType[@name = $strPortName]/IsNotification/tempPortType[tempServiceNodes/tempServiceNode[@pd.id = $strUniqueID and @pd.verb = $strVerb]]/@name" />
		<xsl:variable name="strBusObjVariable">
			<xsl:choose>
				<xsl:when test="pd.busobjvariable = ''">
					<xsl:value-of select="concat(normalize-space($strPortName), 'BusObj')" />
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="pd.busobjvariable" />
				</xsl:otherwise>
			</xsl:choose>			
		</xsl:variable>

		<xsl:variable name="strCompPortName" select="./pd.comp.port" />
		<xsl:variable name="strCompVerb" select="./pd.comp.verb" />										
		<xsl:variable name="strCompPortType" select="document($wsdlServiceInfo)/*/tempServiceLinkType[@name = $strCompPortName]/IsNotification/tempPortType[tempServiceNodes/tempServiceNode[@pd.id = $strUniqueID and @pd.comp.verb = $strCompVerb]]/@name" />
		<xsl:variable name="strCompBusObjVariable">
			<xsl:choose>
				<xsl:when test="pd.comp.busobjvariable = ''">
					<xsl:value-of select="concat(normalize-space($strCompPortName), 'BusObj')" />
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="pd.comp.busobjvariable" />
				</xsl:otherwise>
			</xsl:choose>			
		</xsl:variable>
		
		<xsl:variable name="strLabel">
			<xsl:call-template name="writeLabel" />
		</xsl:variable>
		<xsl:variable name="strCorrelationSetName">
			<xsl:if test="./CorrelationSet and count(document($pdProcess)/*/CorrelationSets/CorrelationSet) &gt; 0">
				<xsl:variable name="strProperties" select="./CorrelationSet/@pd.correlation.properties" />
				<xsl:value-of select="document($pdProcess)/*/CorrelationSets/CorrelationSet[@pd.properties = $strProperties]/@pd.name" />
			</xsl:if>
		 </xsl:variable>
		<xsl:variable name="strInitCorrelationSet">
			<xsl:choose>
				<xsl:when test="./CorrelationSet/@IsInit = 'Yes'">
					<xsl:value-of select="'yes'" />
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="'no'" />
				</xsl:otherwise>			
			</xsl:choose>
		 </xsl:variable>

		<xsl:choose>
			<xsl:when test="($strBusObjVariable = 'triggeringBusObj') and count(xalan:distinct(document($wsdlServiceInfo)/*/tempServiceLinkType/IsRequestResponse[@type = 'Yes']/@variable)) &gt; 1">			
				<!-- If one of the triggering Business object is not of the same BO type as the port type for this scenario , then that is an error in design-->
				<xsl:variable name="strPortName" select="./pd.port" />
				<xsl:variable name="strPortBOType" select="document($wsdlServiceInfo)/*/tempServiceLinkType[@name = $strPortName]/@BusObjType" />
				<xsl:if test="count(document($wsdlServiceInfo)/*/tempServiceLinkType[IsRequestResponse/tempPortType[*]/tempScenarios/tempScenarioInfo[@name= $strScenarioName]]/@BusObjType = $strPortBOType) &gt; 0">
					<xsl:message terminate="yes">
						<xsl:value-of select="'Invalid template. One of the scenario has the triggering Business Object whose data type does not match the data type of a Service Port(s).'" />
					</xsl:message>					
				</xsl:if>
				<xsl:element name="switch">
					<xsl:for-each select="xalan:distinct(document($wsdlServiceInfo)/*/tempServiceLinkType[IsRequestResponse/tempPortType[*]/tempScenarios/tempScenarioInfo[@name= $strScenarioName]])">
						<xsl:element name="case">
							<xsl:attribute name="condition">
								<xsl:for-each select="IsRequestResponse/tempPortType[*]/tempScenarios/tempScenarioInfo[@name = $strScenarioName]">								
									<xsl:if test="position() = 1">
										<xsl:if test="$bUseXPATHExpression">	
											<xsl:text disable-output-escaping="yes">bpws:getVariableData('scenarioTriggeringConditionVar', 'value') = '</xsl:text><xsl:value-of select="concat(./../../../../@name, @verb)" /><xsl:text disable-output-escaping="yes">'</xsl:text>	
										</xsl:if>
										<xsl:if test="not($bUseXPATHExpression)">																								
											<xsl:text disable-output-escaping="yes">"</xsl:text><xsl:value-of select="concat(./../../../../@name, @verb)" /><xsl:text disable-output-escaping="yes">".compareTo(scenarioTriggeringConditionVar) == 0</xsl:text>
										</xsl:if>																																									
									</xsl:if>
									<xsl:if test="position() != 1">
										<xsl:if test="$bUseXPATHExpression">	
											<xsl:text disable-output-escaping="yes"> or bpws:getVariableData('scenarioTriggeringConditionVar', 'value') = '</xsl:text><xsl:value-of select="concat(./../../../../@name, @verb)" /><xsl:text disable-output-escaping="yes">'</xsl:text>	
										</xsl:if>
										<xsl:if test="not($bUseXPATHExpression)">													
											<xsl:text disable-output-escaping="yes"> || "</xsl:text><xsl:value-of select="concat(./../../../../@name, @verb)" /><xsl:text disable-output-escaping="yes">".compareTo(scenarioTriggeringConditionVar) == 0</xsl:text>
										</xsl:if>																																																			
									</xsl:if>
								</xsl:for-each>
							</xsl:attribute>

							<xsl:call-template name="writeInvokeActivity">
								<xsl:with-param name="strLabel" select="$strLabel" />
								<xsl:with-param name="strPartner" select="$strPortName" />
								<xsl:with-param name="strPortType" select="$strPortType" />								
								<xsl:with-param name="strOperation" select="$strVerb" />								
								<xsl:with-param name="strInputVariable" select="./IsRequestResponse/@variable" />
								<xsl:with-param name="strOutputVariable" select="''" />
								<xsl:with-param name="strCompPortName" select="$strCompPortName" />
								<xsl:with-param name="strCompPortType" select="$strCompPortType" />
								<xsl:with-param name="strCompVerb" select="$strCompVerb" />										
								<xsl:with-param name="strCompBusObjVariable" select="$strCompBusObjVariable" />
								<xsl:with-param name="strCorrelationSetName" select="$strCorrelationSetName" />																		
								<xsl:with-param name="strInitCorrelationSet" select="$strInitCorrelationSet" />
								<xsl:with-param name="strScenarioName" select="$strScenarioName" />																																				
							</xsl:call-template>							
						</xsl:element>
					</xsl:for-each>

					<xsl:choose>											
						<xsl:when test="$bWriteNodeLinks">
							<xsl:call-template name="writeNodeLinksInfo" >
								<xsl:with-param name="bWriteTargetMessageLinksOnly" select="$bWriteTargetMessageLinksOnly" />
							</xsl:call-template>
						</xsl:when>
						<xsl:when test="$bWriteTargetMessageLinksOnly">
							<xsl:for-each select="pd.links/pd.targets/pd.link[@type = 'MessageLink']">
								<xsl:element name="target">
									<xsl:attribute name="linkName">					
										<xsl:call-template name="writeLabel">
											<xsl:with-param name="strStdLabel" select="'transitionLink'"/>
										</xsl:call-template>
									</xsl:attribute>				
								</xsl:element>
							</xsl:for-each>
						</xsl:when>
					</xsl:choose>

				</xsl:element>
			</xsl:when>			
			<xsl:otherwise>
				<xsl:call-template name="writeInvokeActivity">
					<xsl:with-param name="strLabel" select="$strLabel" />
					<xsl:with-param name="strPartner" select="$strPortName" />
					<xsl:with-param name="strPortType" select="$strPortType" />								
					<xsl:with-param name="strOperation" select="$strVerb" />								
					<xsl:with-param name="strInputVariable" select="$strBusObjVariable" />
					<xsl:with-param name="strOutputVariable" select="''" />
					<xsl:with-param name="strCompPortName" select="$strCompPortName" />
					<xsl:with-param name="strCompPortType" select="$strCompPortType" />
					<xsl:with-param name="strCompVerb" select="$strCompVerb" />										
					<xsl:with-param name="strCompBusObjVariable" select="$strCompBusObjVariable" />																		
					<xsl:with-param name="strCorrelationSetName" select="$strCorrelationSetName" />																		
					<xsl:with-param name="strInitCorrelationSet" select="$strInitCorrelationSet" />
					<xsl:with-param name="strScenarioName" select="$strScenarioName" />	
					<xsl:with-param name="bWriteTargetMessageLinksOnly" select="$bWriteTargetMessageLinksOnly" />														
					<xsl:with-param name="bWriteNodeLinks" select="$bWriteNodeLinks" />																																								
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template name="writeInboundServiceNode">
	<xsl:param name="strScenarioName" />
	<xsl:param name="bWriteTargetMessageLinksOnly" select="0" />														
	<xsl:param name="bWriteNodeLinks" select="0" />
		<xsl:variable name="strUniqueID" select="./@pd.id" />

		<xsl:variable name="strPortName" select="./pd.port" />
		<xsl:variable name="strVerb" select="./pd.verb" />
		<xsl:variable name="strPortType" select="document($wsdlServiceInfo)/*/tempServiceLinkType[@name = $strPortName]/IsOneWay/tempPortType[tempServiceNodes/tempServiceNode[@pd.id = $strUniqueID and @pd.verb = $strVerb]]/@name" />
		<xsl:variable name="strBusObjVariable">
			<xsl:choose>
				<xsl:when test="pd.busobjvariable = ''">
					<xsl:value-of select="concat(normalize-space($strPortName), 'BusObj')" />
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="pd.busobjvariable" />
				</xsl:otherwise>
			</xsl:choose>			
		</xsl:variable>

		<xsl:variable name="strLabel">
			<xsl:call-template name="writeLabel" />
		</xsl:variable>

		<xsl:variable name="strCorrelationSetName">
			<xsl:if test="./CorrelationSet and count(document($pdProcess)/*/CorrelationSets/CorrelationSet) &gt; 0">
				<xsl:variable name="strProperties" select="./CorrelationSet/@pd.correlation.properties" />
				<xsl:value-of select="document($pdProcess)/*/CorrelationSets/CorrelationSet[@pd.properties = $strProperties]/@pd.name" />
			</xsl:if>
		 </xsl:variable>

		 <xsl:variable name="strTimeOutExpression">
			<xsl:choose>
				<xsl:when test="pd.wait.timeout/@pd.type = 'Constant'">
					<xsl:value-of select="pd.wait.timeout" />
				</xsl:when>
				<xsl:when test="pd.wait.timeout/@pd.type = 'Variable'">
					<xsl:value-of select="pd.wait.timeout" />
				</xsl:when>
				<xsl:when test="pd.wait.timeout/@pd.type = 'Parameter'">
					<xsl:text disable-output-escaping="yes">getConfigProperty("</xsl:text><xsl:value-of select="normalize-space(pd.wait.timeout)" /><xsl:text disable-output-escaping="yes">")</xsl:text>	
				</xsl:when>
				<xsl:otherwise>					
				</xsl:otherwise>
			</xsl:choose>
		 </xsl:variable>

		<xsl:choose>
			<xsl:when test="($strBusObjVariable = 'triggeringBusObj') and count(xalan:distinct(document($wsdlServiceInfo)/*/tempServiceLinkType/IsRequestResponse[@type = 'Yes']/@variable)) &gt; 1">			
				<!-- If one of the triggering Business object is not of the same BO type as the port type for this scenario , then that is an error in design-->
				<xsl:variable name="strPortName" select="./pd.port" />
				<xsl:variable name="strPortBOType" select="document($wsdlServiceInfo)/*/tempServiceLinkType[@name = $strPortName]/@BusObjType" />
				<xsl:if test="count(document($wsdlServiceInfo)/*/tempServiceLinkType[IsRequestResponse/tempPortType[*]/tempScenarios/tempScenarioInfo[@name= $strScenarioName]]/@BusObjType = $strPortBOType) &gt; 0">
					<xsl:message terminate="yes">
						<xsl:value-of select="'Invalid template. One of the scenario has the triggering Business Object whose data type does not match the data type of a Service Port(s).'" />
					</xsl:message>					
				</xsl:if>
				<xsl:element name="switch">
					<xsl:for-each select="xalan:distinct(document($wsdlServiceInfo)/*/tempServiceLinkType[IsRequestResponse/tempPortType[*]/tempScenarios/tempScenarioInfo[@name= $strScenarioName]])">
						<xsl:element name="case">
							<xsl:attribute name="condition">
								<xsl:for-each select="IsRequestResponse/tempPortType[*]/tempScenarios/tempScenarioInfo[@name = $strScenarioName]">								
									<xsl:if test="position() = 1">
										<xsl:if test="$bUseXPATHExpression">	
											<xsl:text disable-output-escaping="yes">bpws:getVariableData('scenarioTriggeringConditionVar', 'value') = '</xsl:text><xsl:value-of select="concat(./../../../../@name, @verb)" /><xsl:text disable-output-escaping="yes">'</xsl:text>	
										</xsl:if>
										<xsl:if test="not($bUseXPATHExpression)">																								
											<xsl:text disable-output-escaping="yes">"</xsl:text><xsl:value-of select="concat(./../../../../@name, @verb)" /><xsl:text disable-output-escaping="yes">".compareTo(scenarioTriggeringConditionVar) == 0</xsl:text>
										</xsl:if>																																																		
									</xsl:if>
									<xsl:if test="position() != 1">
										<xsl:if test="$bUseXPATHExpression">	
											<xsl:text disable-output-escaping="yes"> or bpws:getVariableData('scenarioTriggeringConditionVar', 'value') = '</xsl:text><xsl:value-of select="concat(./../../../../@name, @verb)" /><xsl:text disable-output-escaping="yes">'</xsl:text>	
										</xsl:if>
										<xsl:if test="not($bUseXPATHExpression)">																								
											<xsl:text disable-output-escaping="yes"> || "</xsl:text><xsl:value-of select="concat(./../../../../@name, @verb)" /><xsl:text disable-output-escaping="yes">".compareTo(scenarioTriggeringConditionVar) == 0</xsl:text>
										</xsl:if>																																																			
									</xsl:if>
								</xsl:for-each>
							</xsl:attribute>

							<xsl:call-template name="writeRecieveActivity">
								<xsl:with-param name="strLabel" select="$strLabel" />
								<xsl:with-param name="strPartner" select="$strPortName" />
								<xsl:with-param name="strPortType" select="$strPortType" />								
								<xsl:with-param name="strOperation" select="$strVerb" />								
								<xsl:with-param name="strInputVariable" select="./IsRequestResponse/@variable" />
								<xsl:with-param name="strCorrelationSetName" select="$strCorrelationSetName" />																										
							</xsl:call-template>							
						</xsl:element>
					</xsl:for-each>

					<xsl:choose>											
						<xsl:when test="$bWriteNodeLinks">
							<xsl:call-template name="writeNodeLinksInfo" >
								<xsl:with-param name="bWriteTargetMessageLinksOnly" select="$bWriteTargetMessageLinksOnly" />
							</xsl:call-template>
						</xsl:when>
						<xsl:when test="$bWriteTargetMessageLinksOnly">
							<xsl:for-each select="pd.links/pd.targets/pd.link[@type = 'MessageLink']">
								<xsl:element name="target">
									<xsl:attribute name="linkName">					
										<xsl:call-template name="writeLabel">
											<xsl:with-param name="strStdLabel" select="'transitionLink'"/>
										</xsl:call-template>
									</xsl:attribute>				
								</xsl:element>
							</xsl:for-each>
						</xsl:when>
					</xsl:choose>
				</xsl:element>
			</xsl:when>			
			<xsl:otherwise>
				<xsl:call-template name="writeRecieveActivity">
					<xsl:with-param name="strLabel" select="$strLabel" />
					<xsl:with-param name="strPartner" select="$strPortName" />
					<xsl:with-param name="strPortType" select="$strPortType" />								
					<xsl:with-param name="strOperation" select="$strVerb" />								
					<xsl:with-param name="strInputVariable" select="$strBusObjVariable" />
					<xsl:with-param name="strCorrelationSetName" select="$strCorrelationSetName" />	
					<xsl:with-param name="bWriteTargetMessageLinksOnly" select="$bWriteTargetMessageLinksOnly" />														
					<xsl:with-param name="bWriteNodeLinks" select="$bWriteNodeLinks" />																						
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>		
	</xsl:template>

	<xsl:template name="writeRecieveActivity">
	<xsl:param name="strLabel" />
	<xsl:param name="strPartner" />
	<xsl:param name="strPortType" />
	<xsl:param name="strOperation" />	
	<xsl:param name="strInputVariable" />
	<xsl:param name="strTimeOutExpression" select="''" />
	<xsl:param name="strCorrelationSetName" select="''" />																			
	<xsl:param name="bWriteTargetMessageLinksOnly" select="0" />														
	<xsl:param name="bWriteNodeLinks" select="0" />

		<xsl:element name="receive">
			<xsl:attribute name="name">
				<xsl:value-of select="$strLabel" />
			</xsl:attribute>

			<xsl:attribute name="partner">
				<xsl:value-of select="$strPartner" />
			</xsl:attribute>
			<xsl:attribute name="portType">
				<xsl:value-of select="concat('wsdlWBI:', $strPortType)" />
			</xsl:attribute>
			<xsl:attribute name="operation">
				<xsl:value-of select="$strOperation" />
			</xsl:attribute>
			<xsl:attribute name="variable">
				<xsl:value-of select="$strInputVariable" />
			</xsl:attribute>

			<xsl:if test="not($strTimeOutExpression = '')">
				<xsl:text disable-output-escaping="yes">&lt;wpc:expiration after='</xsl:text>	
					<xsl:value-of select="normalize-space($strTimeOutExpression)" />
				<xsl:text disable-output-escaping="yes">' /></xsl:text>					
			</xsl:if>

			<xsl:call-template name="writeCorrelations">
				<xsl:with-param name="strSet" select="$strCorrelationSetName"/>
				<xsl:with-param name="strInitiate" select="'no'" />								
			</xsl:call-template>							

			<xsl:choose>											
				<xsl:when test="$bWriteNodeLinks">
					<xsl:call-template name="writeNodeLinksInfo" >
						<xsl:with-param name="bWriteTargetMessageLinksOnly" select="$bWriteTargetMessageLinksOnly" />
					</xsl:call-template>
				</xsl:when>
				<xsl:when test="$bWriteTargetMessageLinksOnly">
					<xsl:for-each select="pd.links/pd.targets/pd.link[@type = 'MessageLink']">
						<xsl:element name="target">
							<xsl:attribute name="linkName">					
								<xsl:call-template name="writeLabel">
									<xsl:with-param name="strStdLabel" select="'transitionLink'"/>
								</xsl:call-template>
							</xsl:attribute>				
						</xsl:element>
					</xsl:for-each>
				</xsl:when>
			</xsl:choose>

		</xsl:element>
	</xsl:template>

	<xsl:template name="writeIteratorNode">
	<xsl:param name="strScenarioName" />				
	<xsl:param name="bWriteNodeLinks" select="1" />		

		<xsl:if test="$bWriteNodeLinks">
			<xsl:call-template name="writeIteratorConditionInit" />
		</xsl:if>

		<xsl:variable name="strLabel">
			<xsl:call-template name="writeLabel" />
		</xsl:variable>

		<xsl:element name="while">
			<xsl:attribute name="name">
				<xsl:value-of select="$strLabel" />
			</xsl:attribute>
			<xsl:attribute name="condition">
				<xsl:choose>
					<xsl:when test="pd.type = 'Attribute'">					
						<xsl:if test="$bUseXPATHExpression">	
							<xsl:text disable-output-escaping="yes">bpws:getVariableData("</xsl:text><xsl:value-of select="concat('canContinueVar_', normalize-space($strLabel))" /><xsl:text disable-output-escaping="yes">", "value") = true</xsl:text>		
						</xsl:if>
						<xsl:if test="not($bUseXPATHExpression)">													
							<xsl:value-of select="concat('canContinueVar_', normalize-space($strLabel), ' == true')" />
						</xsl:if>																			
					</xsl:when>						
					<xsl:when test="pd.type = 'BusObj'">					
						<xsl:if test="$bUseXPATHExpression">	
							<xsl:text disable-output-escaping="yes">bpws:getVariableData("</xsl:text><xsl:value-of select="concat('loopIndexVar', normalize-space($strLabel))" /><xsl:text disable-output-escaping="yes">", "value") &lt; </xsl:text> <xsl:value-of select="concat(normalize-space(pd.object), '.size()')" /> 		
						</xsl:if>
						<xsl:if test="not($bUseXPATHExpression)">													
							<xsl:value-of select="concat('loopIndexVar', normalize-space($strLabel), ' &lt; ', normalize-space(pd.object), '.size()')" /> 		
						</xsl:if>																			
					</xsl:when>						
					<xsl:otherwise>
						<xsl:if test="$bUseXPATHExpression">	
							<xsl:text disable-output-escaping="yes">bpws:getVariableData("</xsl:text><xsl:value-of select="concat('loopIndexVar', normalize-space($strLabel))" /><xsl:text disable-output-escaping="yes">", "value") &lt; </xsl:text> <xsl:value-of select="normalize-space(pd.condition)" /> 		
						</xsl:if>
						<xsl:if test="not($bUseXPATHExpression)">													
							<xsl:value-of select="concat('loopIndexVar', normalize-space($strLabel), ' &lt; ', normalize-space(pd.condition))" /> 		
						</xsl:if>																									
					</xsl:otherwise>
				</xsl:choose>				
			</xsl:attribute>

			<xsl:element name="flow">	
						
				<xsl:call-template name="writeLinks">
					<xsl:with-param name="bForIterator" select="1" />
				</xsl:call-template>

				<!-- if start does not exist, or more than one start node exists, then throw an error. -->
				<xsl:if test="not(count(pd.nodes/*[count(./pd.links/pd.targets/pd.link) = 0 and name(.) = 'InitialNode']) = 1)">
					<xsl:message terminate="yes">
						<xsl:value-of select="'Invalid Iterator. Has none or more than one start node.'" />
					</xsl:message>				
				</xsl:if>						

				<!-- if there is any node which don't have any incoming link other than the start node that is also an error -->
				<xsl:if test="pd.nodes/*[count(./pd.links/pd.targets/pd.link) = 0 and not(name(.) = 'InitialNode')]">
					<xsl:message terminate="yes">
						<xsl:value-of select="'Invalid Iterator. Has one or more non-standard start node(s).'" />
					</xsl:message>				
				</xsl:if>						

				<!-- if there is any node which don't have any outgoing link other than the success end, failure end,break and service call types that is also an error -->
				<xsl:if test="pd.nodes/*[count(./pd.links/pd.sources/pd.link) = 0 and (name(.) = 'InitialNode' or name(.) = 'ActionNode' or name(.) = 'SubDiagramNode' or name(.) = 'IteratorNode')]">
					<xsl:message terminate="yes">
						<xsl:value-of select="'Invalid Iterator. Has one or more non-standard end node(s).'" />
					</xsl:message>				
				</xsl:if>

				<xsl:call-template name="writeIteratorVariableInit" />

				<xsl:for-each select="pd.nodes/*">
					<xsl:choose>
						<xsl:when test="count(./pd.links/pd.sources/pd.link[@type = 'ExceptionLink']) &gt; 0 or (name(.) = 'IteratorNode' and count(pd.nodes/*[name(.) = 'BreakNode']) &gt; 0)">
							<xsl:call-template name="writeNodeWithScope">												
								<xsl:with-param name="strScenarioName" select="$strScenarioName" />			
								<xsl:with-param name="strIteratorLabel" select="$strLabel" />
							</xsl:call-template>
						</xsl:when>
						<xsl:otherwise>
							<xsl:call-template name="writeNode">				
								<xsl:with-param name="bForIterator" select="1" />
								<xsl:with-param name="strScenarioName" select="$strScenarioName" />			
								<xsl:with-param name="strIteratorLabel" select="$strLabel" />
								<xsl:with-param name="bFromScenarioDiagram" select="0" />			
							</xsl:call-template>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:for-each>									

				<xsl:call-template name="writeIteratorConditionIncrement" />

			</xsl:element>

			<xsl:call-template name="writeDescription">
				<xsl:with-param name="strDesc" select="pd.desc"/>
			</xsl:call-template>

			<xsl:if test="$bWriteNodeLinks">
				<xsl:element name="target">
					<xsl:attribute name="linkName">
						<xsl:value-of select="concat('transitionLink_Initialize_', normalize-space($strLabel))" />
					</xsl:attribute>		
				</xsl:element>

				<xsl:call-template name="writeSourceNodeLinksInfo" />
			</xsl:if>
		</xsl:element>
	</xsl:template>


	<xsl:template name="writeIteratorConditionInit">
		
		<xsl:variable name="strLabel">
			<xsl:call-template name="writeLabel" />
		</xsl:variable>

		<!-- depending on the type of the iterator -->
		<xsl:variable name="strInitialValue">
			<xsl:choose>
				<xsl:when test="pd.type = 'Attribute'">					
					<xsl:value-of select="'true'" />
				</xsl:when>						
				<xsl:when test="pd.type = 'BusObj'">					
					<xsl:value-of select="'0'" />
				</xsl:when>						
				<xsl:otherwise>
					<xsl:value-of select="pd.start" />															
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>

		<xsl:variable name="strVariable">
			<xsl:choose>
				<xsl:when test="pd.type = 'Attribute'">					
					<xsl:value-of select="concat('canContinueVar_', normalize-space($strLabel))" />						
				</xsl:when>						
				<xsl:otherwise>
					<xsl:value-of select="concat('loopIndexVar', normalize-space($strLabel))" />
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>

		<xsl:element name="assign">
			<xsl:element name="copy">
				<xsl:element name="from">
					<xsl:attribute name="expression">
						<xsl:value-of select="$strInitialValue" />
					</xsl:attribute>							
				</xsl:element>
				<xsl:element name="to">
					<xsl:attribute name="variable">
						<xsl:value-of select="$strVariable" />
					</xsl:attribute>							
					<xsl:attribute name="part">
						<xsl:value-of select="'value'" />
					</xsl:attribute>							
				</xsl:element>				
			</xsl:element>				
			<xsl:if test="pd.type = 'Attribute'">					
				<xsl:element name="copy">
					<xsl:element name="from">
						<xsl:attribute name="expression">
							<xsl:value-of select="'0'" />
						</xsl:attribute>							
					</xsl:element>
					<xsl:element name="to">
						<xsl:attribute name="variable">
							<xsl:value-of select="concat('loopIndexVar', normalize-space($strLabel))" />
						</xsl:attribute>							
						<xsl:attribute name="part">
							<xsl:value-of select="'value'" />
						</xsl:attribute>							
					</xsl:element>				
				</xsl:element>				
			</xsl:if>

			<xsl:call-template name="writeTargetNodeLinksInfo" />

			<xsl:element name="source">
				<xsl:attribute name="linkName">
					<xsl:value-of select="concat('transitionLink_Initialize_', normalize-space($strLabel))" />
				</xsl:attribute>		
			</xsl:element>
		</xsl:element>
	</xsl:template>

	<xsl:template name="writeIteratorConditionIncrement">

		<xsl:variable name="strLabel">
			<xsl:call-template name="writeLabel" />
		</xsl:variable>

		<xsl:choose>
			<xsl:when test="pd.type = 'Attribute'">					
				<xsl:text disable-output-escaping="yes">&lt;wpc:script></xsl:text>
					<xsl:value-of select="$newline" />

					<xsl:variable name="strFunctionName">
						<xsl:choose>
							<xsl:when test="pd.type ='Attribute'">
								<xsl:value-of select="'get'" />
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="'elementAt'" />
							</xsl:otherwise>
						</xsl:choose>
					</xsl:variable>							

					<xsl:text disable-output-escaping="yes">&lt;wpc:code language="Java"></xsl:text>												
						<xsl:value-of select="'try {'" />						
						<xsl:value-of select="$newline" />						
						<xsl:value-of select="concat('loopIndexVar', normalize-space($strLabel), '++;')" />
						<xsl:value-of select="$newline" />						
						<xsl:value-of select="concat(pd.object, '.',  $strFunctionName, '(loopIndexVar_', normalize-space($strLabel), ');')" />
						<xsl:value-of select="$newline" />
						<xsl:value-of select="' }'" />												
						<xsl:value-of select="$newline" />
						<xsl:value-of select="'catch (Throwable e) {'" />												
						<xsl:value-of select="$newline" />
						<xsl:value-of select="concat('canContinueVar_', normalize-space($strLabel),' = false;')" />												
						<xsl:value-of select="$newline" />
						<xsl:value-of select="' }'" />												

					<xsl:text disable-output-escaping="yes">
						&lt;/wpc:code>
					</xsl:text>

					<xsl:element name="target">
						<xsl:attribute name="linkName">
							<xsl:value-of select="concat('transitionLink_Increment_', normalize-space($strLabel))" />
						</xsl:attribute>		
					</xsl:element>

				<xsl:text disable-output-escaping="yes">
					&lt;/wpc:script>
				</xsl:text>
			</xsl:when>
			<xsl:otherwise>
				<xsl:element name="assign">
					<xsl:element name="copy">
						<xsl:element name="from">
							<xsl:attribute name="expression">
								<xsl:value-of select="concat('loopIndexVar', normalize-space($strLabel), ' + 1')" />
							</xsl:attribute>							
						</xsl:element>
						<xsl:element name="to">
							<xsl:attribute name="variable">
								<xsl:value-of select="concat('loopIndexVar', normalize-space($strLabel))" />
							</xsl:attribute>							
							<xsl:attribute name="part">
								<xsl:value-of select="'value'" />
							</xsl:attribute>							
						</xsl:element>
					</xsl:element>				

					<xsl:element name="target">
						<xsl:attribute name="linkName">
							<xsl:value-of select="concat('transitionLink_Increment_', normalize-space($strLabel))" />
						</xsl:attribute>		
					</xsl:element>
				</xsl:element>

			</xsl:otherwise>			
		</xsl:choose>

	</xsl:template>

	<xsl:template name="writeIteratorVariableInit">

		<xsl:variable name="strLabel">
			<xsl:call-template name="writeLabel" />
		</xsl:variable>

		<xsl:choose>
			<xsl:when test="not(pd.type = 'Loop')">					
				<xsl:text disable-output-escaping="yes">&lt;wpc:script></xsl:text>
					<xsl:value-of select="$newline" />

					<xsl:variable name="strFunctionName">
						<xsl:choose>
							<xsl:when test="pd.type ='Attribute'">
								<xsl:value-of select="'get'" />
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="'elementAt'" />
							</xsl:otherwise>
						</xsl:choose>
					</xsl:variable>							

					<xsl:text disable-output-escaping="yes">&lt;wpc:code language="Java"></xsl:text>						
						<xsl:value-of select="concat(pd.temp.variable, ' = ', pd.object, '.',  $strFunctionName, '(loopIndexVar_', normalize-space($strLabel), ');')" />
					<xsl:text disable-output-escaping="yes">
						&lt;/wpc:code>
					</xsl:text>

					<xsl:element name="source">
						<xsl:attribute name="linkName">
							<xsl:value-of select="concat('transitionLink__CurrentVar_', normalize-space($strLabel))" />
						</xsl:attribute>		
					</xsl:element>

				<xsl:text disable-output-escaping="yes">
					&lt;/wpc:script>
				</xsl:text>
			</xsl:when>
			<xsl:otherwise>
				<xsl:element name="empty">
					<xsl:element name="source">
						<xsl:attribute name="linkName">
							<xsl:value-of select="concat('transitionLink__CurrentVar_', normalize-space($strLabel))" />
						</xsl:attribute>		
					</xsl:element>
				</xsl:element>
			</xsl:otherwise>			
		</xsl:choose>

	</xsl:template>

	<xsl:template name="writeSubDiagramNode">
	<xsl:param name="strScenarioName" />	
	<xsl:param name="bWriteNodeLinks" select="1" />			

		<xsl:element name="flow">	
			<xsl:attribute name="name">
				<xsl:call-template name="writeLabel" />
			</xsl:attribute>

			<xsl:call-template name="writeLinks" />

			<!-- if start does not exist, or more than one start node exists, then throw an error. -->
			<xsl:if test="not(count(pd.nodes/*[count(./pd.links/pd.targets/pd.link) = 0 and name(.) = 'InitialNode']) = 1)">
				<xsl:message terminate="yes">
					<xsl:value-of select="'Invalid subdiagram. Has none or more than one start node.'" />
				</xsl:message>				
			</xsl:if>

			<!-- if there is any node which don't have any incoming link other than the start node that is also an error -->
			<xsl:if test="pd.nodes/*[count(./pd.links/pd.targets/pd.link) = 0 and not(name(.) = 'InitialNode')]">
				<xsl:message terminate="yes">
					<xsl:value-of select="'Invalid subdiagram. Has one or more non-standard start node(s).'" />
				</xsl:message>				
			</xsl:if>						

			<!-- if there is any node which don't have any outgoing link other than the success end, failure end,break and service call types that is also an error -->
			<xsl:if test="pd.nodes/*[count(./pd.links/pd.sources/pd.link) = 0 and (name(.) = 'InitialNode' or name(.) = 'ActionNode' or name(.) = 'SubDiagramNode' or name(.) = 'IteratorNode')]">
				<xsl:message terminate="yes">
					<xsl:value-of select="'Invalid subdiagram. Has one or more non-standard end node(s).'" />
				</xsl:message>				
			</xsl:if>


			<xsl:for-each select="pd.nodes/*">
				<xsl:choose>
					<xsl:when test="count(./pd.links/pd.sources/pd.link[@type = 'ExceptionLink']) &gt; 0 or (name(.) = 'IteratorNode' and count(pd.nodes/*[name(.) = 'BreakNode']) &gt; 0)">
						<xsl:call-template name="writeNodeWithScope">				
							<xsl:with-param name="strScenarioName" select="$strScenarioName" />			
						</xsl:call-template>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="writeNode">				
							<xsl:with-param name="strScenarioName" select="$strScenarioName" />			
							<xsl:with-param name="bFromScenarioDiagram" select="0" />			
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:for-each>			

			<xsl:call-template name="writeDescription">
				<xsl:with-param name="strDesc" select="pd.desc"/>
			</xsl:call-template>
			
			<xsl:if test="$bWriteNodeLinks">
				<xsl:call-template name="writeNodeLinksInfo" />
			</xsl:if>
	
		</xsl:element>

	</xsl:template>

	<xsl:template name="writeSuccessEndNode">
	<xsl:param name="bFromScenarioDiagram" />			
	<xsl:param name="strScenarioName" select="''" />
	<xsl:param name="strIteratorLabel" select="''" />
		
		<xsl:variable name="nodeTempScenarioInfo" select="document($wsdlServiceInfo)/*/tempServiceLinkType[*]/IsRequestResponse/tempPortType[*]/tempScenarios/tempScenarioInfo[@name = $strScenarioName]" />				
		
		<xsl:choose>
			<xsl:when test="$bFromScenarioDiagram and count($nodeTempScenarioInfo) = 1">
				<xsl:element name="reply">
					<xsl:attribute name="name">
						<xsl:call-template name="writeLabel" />
					</xsl:attribute>

					<xsl:attribute name="partner">
						<xsl:value-of select="$nodeTempScenarioInfo/../../../../@name" />
					</xsl:attribute>
					<xsl:attribute name="portType">
						<xsl:value-of select="concat('wsdlWBI:', $nodeTempScenarioInfo/../../@name)" />
					</xsl:attribute>
					<xsl:attribute name="operation">
						<xsl:value-of select="$nodeTempScenarioInfo/@verb" />
					</xsl:attribute>
					<xsl:attribute name="variable">
						<xsl:value-of select="$nodeTempScenarioInfo/../../../@variable" />
					</xsl:attribute>

					<xsl:call-template name="writeDescription">
						<xsl:with-param name="strDesc" select="pd.desc"/>
					</xsl:call-template>

					<xsl:call-template name="writeNodeLinksInfoForEndNode">
						<xsl:with-param name="strIteratorLabel" select="$strIteratorLabel" />
					</xsl:call-template>
				</xsl:element>
			</xsl:when>
			<xsl:when test="$bFromScenarioDiagram and count($nodeTempScenarioInfo) &gt; 1">
				<xsl:variable name="strLabel">
					<xsl:call-template name="writeLabel" />
				</xsl:variable>

				<xsl:element name="switch">

					<xsl:attribute name="name">									
						<xsl:value-of select="$strLabel" />						
					</xsl:attribute>

					<xsl:for-each select="$nodeTempScenarioInfo">
						<xsl:element name="case">
							<xsl:attribute name="condition">
								<xsl:if test="$bUseXPATHExpression">	
									<xsl:text disable-output-escaping="yes">bpws:getVariableData('scenarioTriggeringConditionVar', 'value') = '</xsl:text><xsl:value-of select="concat(./../../../../@name, @verb)" /><xsl:text disable-output-escaping="yes">'</xsl:text>	
								</xsl:if>
								<xsl:if test="not($bUseXPATHExpression)">																						
									<xsl:text disable-output-escaping="yes">"</xsl:text><xsl:value-of select="concat(./../../../../@name, @verb)" /><xsl:text disable-output-escaping="yes">".compareTo(scenarioTriggeringConditionVar) == 0</xsl:text>
								</xsl:if>															
							</xsl:attribute>

							<xsl:element name="reply">
								<xsl:attribute name="name">									
									<xsl:value-of select="concat($strLabel, '_', position())" />						
								</xsl:attribute>

								<xsl:attribute name="partner">
									<xsl:value-of select="./../../../../@name" />
								</xsl:attribute>
								<xsl:attribute name="portType">
									<xsl:value-of select="concat('wsdlWBI:', ./../../@name)" />
								</xsl:attribute>
								<xsl:attribute name="operation">
									<xsl:value-of select="@verb" />
								</xsl:attribute>
								<xsl:attribute name="variable">
									<xsl:value-of select="./../../../@variable" />
								</xsl:attribute>
							</xsl:element>
						</xsl:element>
					</xsl:for-each>

					<xsl:call-template name="writeDescription">
						<xsl:with-param name="strDesc" select="pd.desc"/>
					</xsl:call-template>

					<xsl:call-template name="writeNodeLinksInfoForEndNode">
						<xsl:with-param name="strIteratorLabel" select="$strIteratorLabel" />
					</xsl:call-template>
				</xsl:element>
			</xsl:when>
			<xsl:otherwise>
				<xsl:element name="empty">
					<xsl:attribute name="name">
						<xsl:call-template name="writeLabel" />
					</xsl:attribute>

					<xsl:call-template name="writeDescription">
						<xsl:with-param name="strDesc" select="pd.desc"/>
					</xsl:call-template>

					<xsl:call-template name="writeNodeLinksInfoForEndNode">
						<xsl:with-param name="strIteratorLabel" select="$strIteratorLabel" />
					</xsl:call-template>
				</xsl:element>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template name="writeNodeLinksInfoForEndNode">
	<xsl:param name="strIteratorLabel" select="''" />

		<xsl:choose>
			<xsl:when test="not($strIteratorLabel = '')">
				<xsl:call-template name="writeTargetNodeLinksInfo" />

				<xsl:element name="source">
					<xsl:attribute name="linkName">
						<xsl:value-of select="concat('transitionLink_Increment_', normalize-space($strIteratorLabel))" />
					</xsl:attribute>		
				</xsl:element>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="writeNodeLinksInfo" />
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>


	<xsl:template name="writeFailureEndNode">
	<xsl:param name="strIteratorLabel" select="''" />

		<xsl:element name="sequence">
			<xsl:element name="assign">
				<xsl:element name="copy">
					<xsl:element name="from">
						<xsl:attribute name="expression">
							<xsl:if test="$bUseXPATHExpression">	
								<xsl:value-of select="'ConsumerException'" />
							</xsl:if>
							<xsl:if test="not($bUseXPATHExpression)">													
								<xsl:text disable-output-escaping="yes">"ConsumerException"</xsl:text>
							</xsl:if>							
						</xsl:attribute>							
					</xsl:element>
					<xsl:element name="to">
						<xsl:attribute name="variable">
							<xsl:value-of select="'currentException'" />
						</xsl:attribute>							
						<xsl:attribute name="part">
							<xsl:value-of select="'genericFault'" />
						</xsl:attribute>							
						<xsl:attribute name="query">
							<xsl:value-of select="'/type'" />
						</xsl:attribute>							
					</xsl:element>
				</xsl:element>
				<xsl:element name="copy">
					<xsl:element name="from">
						<xsl:attribute name="expression">
							<xsl:if test="$bUseXPATHExpression">	
								<xsl:value-of select="''" />
							</xsl:if>
							<xsl:if test="not($bUseXPATHExpression)">													
								<xsl:text disable-output-escaping="yes">""</xsl:text>
							</xsl:if>							
						</xsl:attribute>							
					</xsl:element>
					<xsl:element name="to">
						<xsl:attribute name="variable">
							<xsl:value-of select="'currentException'" />
						</xsl:attribute>							
						<xsl:attribute name="part">
							<xsl:value-of select="'genericFault'" />
						</xsl:attribute>							
						<xsl:attribute name="query">
							<xsl:value-of select="'/subType'" />
						</xsl:attribute>							
					</xsl:element>
				</xsl:element>
				<xsl:element name="copy">
					<xsl:element name="from">
						<xsl:attribute name="expression">
							<xsl:if test="$bUseXPATHExpression">	
								<xsl:value-of select="pd.desc" />
							</xsl:if>
							<xsl:if test="not($bUseXPATHExpression)">													
								<xsl:text disable-output-escaping="yes">"</xsl:text><xsl:value-of select="pd.desc" /><xsl:text disable-output-escaping="yes">"</xsl:text>
							</xsl:if>														
						</xsl:attribute>							
					</xsl:element>
					<xsl:element name="to">
						<xsl:attribute name="variable">
							<xsl:value-of select="'currentException'" />
						</xsl:attribute>							
						<xsl:attribute name="part">
							<xsl:value-of select="'genericFault'" />
						</xsl:attribute>							
						<xsl:attribute name="query">
							<xsl:value-of select="'/description'" />
						</xsl:attribute>							
					</xsl:element>
				</xsl:element>

			</xsl:element>

			<xsl:element name="throw">
				<xsl:attribute name="name">
					<xsl:call-template name="writeLabel" />
				</xsl:attribute>
				<xsl:attribute name="faultVariable">
					<xsl:value-of select="'currentException'" />
				</xsl:attribute>

				<xsl:call-template name="writeDescription">
					<xsl:with-param name="strDesc" select="pd.desc"/>
				</xsl:call-template>

			</xsl:element>

			<xsl:call-template name="writeNodeLinksInfoForEndNode">
				<xsl:with-param name="strIteratorLabel" select="$strIteratorLabel" />
			</xsl:call-template>
		</xsl:element>
	</xsl:template>

	<xsl:template name="writeBreakNode">
		<xsl:element name="throw">
			<xsl:attribute name="name">
				<xsl:call-template name="writeLabel" />
			</xsl:attribute>
			<xsl:attribute name="faultName">
				<xsl:value-of select="'tns:genericBreakFault'" />
			</xsl:attribute>

			<xsl:call-template name="writeDescription">
				<xsl:with-param name="strDesc" select="pd.desc"/>
			</xsl:call-template>

			<xsl:call-template name="writeNodeLinksInfo" />			
		</xsl:element>
	</xsl:template>

	<xsl:template name="writeLinks">
	<xsl:param name="bForIterator" select="0" />

		<xsl:element name="links">
			<xsl:for-each select="./pd.nodes/*/pd.links/pd.sources/pd.link">
				<xsl:if test="not(name(./../../..) = 'OutboundServiceNode') and not(name(./../../..) = 'InboundServiceNode')">
					<xsl:element name="link">
						<xsl:attribute name="name">
						<xsl:call-template name="writeLabel">
							<xsl:with-param name="strStdLabel" select="'transitionLink'"/>
						</xsl:call-template>
						</xsl:attribute>
					</xsl:element>
				</xsl:if>
			</xsl:for-each>

			<xsl:for-each select="./pd.nodes/*[name(.) = 'IteratorNode']">
				<xsl:variable name="strLabel">
					<xsl:call-template name="writeLabel" />
				</xsl:variable>

				<xsl:element name="link">
					<xsl:attribute name="name">
						<xsl:value-of select="concat('transitionLink_Initialize_', normalize-space($strLabel))" />
					</xsl:attribute>
				</xsl:element>
			</xsl:for-each>

			<xsl:if test="$bForIterator">
				<xsl:variable name="strLabel">
					<xsl:call-template name="writeLabel" />
				</xsl:variable>

				<xsl:element name="link">
					<xsl:attribute name="name">
						<xsl:value-of select="concat('transitionLink__CurrentVar_', normalize-space($strLabel))" />
					</xsl:attribute>
				</xsl:element>

				<xsl:element name="link">
					<xsl:attribute name="name">
						<xsl:value-of select="concat('transitionLink_Increment_', normalize-space($strLabel))" />
					</xsl:attribute>
				</xsl:element>
			</xsl:if>
		</xsl:element>
	</xsl:template>

	<xsl:template name="writeNodeLinksInfo">
	<xsl:param name="bWriteTargetMessageLinksOnly" select="0" />
	<xsl:param name="bWriteSourceMessageLinksOnly" select="0" />

		<xsl:call-template name="writeTargetNodeLinksInfo">
			<xsl:with-param name="bWriteTargetMessageLinksOnly" select="$bWriteTargetMessageLinksOnly" />		
		</xsl:call-template>

		<xsl:call-template name="writeSourceNodeLinksInfo">
			<xsl:with-param name="bWriteSourceMessageLinksOnly" select="$bWriteSourceMessageLinksOnly" />		
		</xsl:call-template>
	</xsl:template>



	<xsl:template name="writeTargetNodeLinksInfo">
	<xsl:param name="bWriteTargetMessageLinksOnly" select="0" />
		<xsl:choose>
			<xsl:when test="$bWriteTargetMessageLinksOnly">
				<xsl:for-each select="pd.links/pd.targets/pd.link[@type = 'MessageLink']">
					<xsl:element name="target">
						<xsl:attribute name="linkName">					
							<xsl:call-template name="writeLabel">
								<xsl:with-param name="strStdLabel" select="'transitionLink'"/>
							</xsl:call-template>
						</xsl:attribute>				
					</xsl:element>
				</xsl:for-each>
			</xsl:when>
			<xsl:otherwise>
				<xsl:for-each select="pd.links/pd.targets/pd.link[not(@type = 'MessageLink')]">
					<xsl:element name="target">
						<xsl:attribute name="linkName">					
							<xsl:call-template name="writeLabel">
								<xsl:with-param name="strStdLabel" select="'transitionLink'"/>
							</xsl:call-template>
						</xsl:attribute>				
					</xsl:element>
				</xsl:for-each>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template name="writeSourceNodeLinksInfo">
	<xsl:param name="bWriteSourceMessageLinksOnly" select="0" />
		<xsl:choose>
			<xsl:when test="$bWriteSourceMessageLinksOnly">
				<xsl:for-each select="pd.links/pd.sources/pd.link[@type = 'MessageLink']">
					<xsl:element name="source">
						<xsl:attribute name="linkName">
							<xsl:call-template name="writeLabel">
								<xsl:with-param name="strStdLabel" select="'transitionLink'"/>
							</xsl:call-template>
						</xsl:attribute>		
					</xsl:element>
				</xsl:for-each>				
			</xsl:when>
			<xsl:otherwise>
				<xsl:for-each select="pd.links/pd.sources/pd.link[@type = 'TransitionLink']">
					<xsl:element name="source">
						<xsl:attribute name="linkName">
							<xsl:call-template name="writeLabel">
								<xsl:with-param name="strStdLabel" select="'transitionLink'"/>
							</xsl:call-template>
						</xsl:attribute>		

						<xsl:if test="normalize-space(pd.condition)">
							<xsl:attribute name="transitionCondition">
								<xsl:if test="$bUseXPATHExpression">	
									<xsl:value-of select="normalize-space(pd.condition)"/>
								</xsl:if>
								<xsl:if test="not($bUseXPATHExpression)">													
									<xsl:value-of select="normalize-space(pd.condition)"/>
								</xsl:if>
							</xsl:attribute>		
						</xsl:if>								
					</xsl:element>
				</xsl:for-each>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>								


	<xsl:template name="writeNodeLinksInfoWithFaultHandling">
	<xsl:param name="bWriteTargetMessageLinksOnly" select="0" />
	<xsl:param name="bWriteSourceMessageLinksOnly" select="0" />

		<xsl:call-template name="writeTargetNodeLinksInfoWithFaultHandling">
			<xsl:with-param name="bWriteTargetMessageLinksOnly" select="$bWriteTargetMessageLinksOnly" />		
		</xsl:call-template>

		<xsl:call-template name="writeSourceNodeLinksInfoWithFaultHandling">
			<xsl:with-param name="bWriteSourceMessageLinksOnly" select="$bWriteSourceMessageLinksOnly" />		
		</xsl:call-template>
	</xsl:template>

	<xsl:template name="writeTargetNodeLinksInfoWithFaultHandling">
	<xsl:param name="bWriteTargetMessageLinksOnly" select="0" />
		<xsl:choose>
			<xsl:when test="$bWriteTargetMessageLinksOnly">
				<xsl:for-each select="pd.links/pd.targets/pd.link[@type = 'MessageLink']">
					<xsl:element name="target">
						<xsl:attribute name="linkName">					
							<xsl:call-template name="writeLabel">
								<xsl:with-param name="strStdLabel" select="'transitionLink'"/>
							</xsl:call-template>
						</xsl:attribute>				
					</xsl:element>
				</xsl:for-each>
			</xsl:when>
			<xsl:otherwise>
				<xsl:for-each select="pd.links/pd.targets/pd.link[not(@type = 'MessageLink')]">
					<xsl:element name="target">
						<xsl:attribute name="linkName">					
							<xsl:call-template name="writeLabel">
								<xsl:with-param name="strStdLabel" select="'transitionLink'"/>
							</xsl:call-template>
						</xsl:attribute>				
					</xsl:element>
				</xsl:for-each>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template name="writeSourceNodeLinksInfoWithFaultHandling">
	<xsl:param name="bWriteSourceMessageLinksOnly" select="0" />
		<xsl:choose>
			<xsl:when test="$bWriteSourceMessageLinksOnly">
				<xsl:for-each select="pd.links/pd.sources/pd.link[@type = 'MessageLink']">
					<xsl:element name="source">
						<xsl:attribute name="linkName">
							<xsl:call-template name="writeLabel">
								<xsl:with-param name="strStdLabel" select="'transitionLink'"/>
							</xsl:call-template>
						</xsl:attribute>		
					</xsl:element>
				</xsl:for-each>				
			</xsl:when>
			<xsl:otherwise>
				<xsl:for-each select="pd.links/pd.sources/pd.link[@type = 'TransitionLink']">
					<xsl:element name="source">
						<xsl:attribute name="linkName">
							<xsl:call-template name="writeLabel">
								<xsl:with-param name="strStdLabel" select="'transitionLink'"/>
							</xsl:call-template>
						</xsl:attribute>		
						
						<xsl:attribute name="transitionCondition">					
							<xsl:if test="normalize-space(pd.condition)">							
								<xsl:if test="$bUseXPATHExpression">	
									<xsl:value-of select="concat(normalize-space(pd.condition), ' and ')"/>
								</xsl:if>
								<xsl:if test="not($bUseXPATHExpression)">													
									<xsl:value-of select="concat(normalize-space(pd.condition), ' &amp;&amp; ')"/>
								</xsl:if>																																																			
							</xsl:if>
							<xsl:for-each select="../pd.link[@type = 'ExceptionLink']">										
								<xsl:if test="position() = 1">							
									<xsl:if test="$bUseXPATHExpression">	
										<xsl:text disable-output-escaping="yes">not(bpws:getVariableData('exceptionConditionVar', 'value') = '</xsl:text><xsl:value-of select="normalize-space(pd.condition)" /><xsl:text disable-output-escaping="yes">')</xsl:text>								
									</xsl:if>
									<xsl:if test="not($bUseXPATHExpression)">																							
										<xsl:text disable-output-escaping="yes">!("</xsl:text><xsl:value-of select="normalize-space(pd.condition)" /><xsl:text disable-output-escaping="yes">".compareTo(exceptionConditionVar) == 0)</xsl:text>	
									</xsl:if>																																						
								</xsl:if>
								<xsl:if test="not(position() = 1)">							
									<xsl:if test="$bUseXPATHExpression">	
										<xsl:text disable-output-escaping="yes"> and not(bpws:getVariableData('exceptionConditionVar', 'value') = '</xsl:text><xsl:value-of select="normalize-space(pd.condition)" /><xsl:text disable-output-escaping="yes">')</xsl:text>								
									</xsl:if>
									<xsl:if test="not($bUseXPATHExpression)">													
										<xsl:text disable-output-escaping="yes"> &amp;&amp; !("</xsl:text><xsl:value-of select="normalize-space(pd.condition)" /><xsl:text disable-output-escaping="yes">".compareTo(exceptionConditionVar) == 0)</xsl:text>											
									</xsl:if>																																													
								</xsl:if>						
							</xsl:for-each>
						</xsl:attribute>								
					</xsl:element>
				</xsl:for-each>
				<xsl:for-each select="pd.links/pd.sources/pd.link[@type = 'ExceptionLink']">
					<xsl:element name="source">
						<xsl:attribute name="linkName">
							<xsl:call-template name="writeLabel">
								<xsl:with-param name="strStdLabel" select="'transitionLink'"/>
							</xsl:call-template>
						</xsl:attribute>		
						
						<xsl:attribute name="transitionCondition">					
							<xsl:if test="$bUseXPATHExpression">	
								<xsl:text disable-output-escaping="yes">bpws:getVariableData('exceptionConditionVar', 'value') = '</xsl:text><xsl:value-of select="normalize-space(pd.condition)" /><xsl:text disable-output-escaping="yes">'</xsl:text>								
							</xsl:if>
							<xsl:if test="not($bUseXPATHExpression)">													
								<xsl:text disable-output-escaping="yes">("</xsl:text><xsl:value-of select="normalize-space(pd.condition)" /><xsl:text disable-output-escaping="yes">".compareTo(exceptionConditionVar) == 0)</xsl:text>								
							</xsl:if>																																					
						</xsl:attribute>								
					</xsl:element>
				</xsl:for-each>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>


	<xsl:template name="writeLabel">
	<xsl:param name="strStdLabel" select="''"/>
		<xsl:choose>
			<xsl:when test="normalize-space(@pd.label) = ''">
				<xsl:value-of select="concat($strStdLabel, @pd.id)" />							
			</xsl:when>
			<xsl:otherwise>			
				<xsl:value-of select="concat(translate(normalize-space(@pd.label), '&#10;: ', '___'), @pd.id)" />						
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template name="writeDescription">
	<xsl:param name="strDesc" select="''"/>
		<xsl:text disable-output-escaping="yes">&lt;wpc:description></xsl:text>	
			<xsl:value-of select="normalize-space($strDesc)" />
		<xsl:text disable-output-escaping="yes">&lt;/wpc:description></xsl:text>	
	</xsl:template>


	
	<xsl:template name="writeCorrelations">
	<xsl:param name="strSet" />
	<xsl:param name="strInitiate" />
	<xsl:param name="strPattern" select="''" />
		<xsl:if test="not($strSet = '')">
			<xsl:element name="correlations">								
				<xsl:element name="correlation">
					<xsl:attribute name="set">
						<xsl:value-of select="$strSet" />
					</xsl:attribute>
					<xsl:attribute name="initiate">
						<xsl:value-of select="$strInitiate" />
					</xsl:attribute>
					<xsl:if test="not($strPattern = '')">
						<xsl:attribute name="pattern">
							<xsl:value-of select="$strPattern" />
						</xsl:attribute>
					</xsl:if>
				</xsl:element>
			</xsl:element>
		</xsl:if>
	</xsl:template>

</xsl:stylesheet>
