<?xml version="1.0" encoding="UTF-8"?>

<xsl:stylesheet 
	version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
	xmlns:xalan="http://xml.apache.org/xalan"
	exclude-result-prefixes="xalan">

	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>	
	<xsl:param name="wsdlServiceInfo" />

	<xsl:strip-space elements="*" />

	<xsl:template match="/">
		<xsl:variable name="nodePortMessages" select="document($wsdlServiceInfo)/*" />		

		<xsl:text disable-output-escaping="yes">&lt;definitions name="</xsl:text><xsl:value-of select="/CollabTemplate/@Name" /><xsl:text disable-output-escaping="yes">"</xsl:text>
		<xsl:text disable-output-escaping="yes"> targetNamespace="</xsl:text><xsl:value-of select="concat('http://tempuri.org/IBM/WBI/', normalize-space(/CollabTemplate/@Name), '/definitions')" /><xsl:text disable-output-escaping="yes">"</xsl:text>
		<xsl:text disable-output-escaping="yes"> xmlns:tns="</xsl:text><xsl:value-of select="concat('http://tempuri.org/IBM/WBI/', normalize-space(/CollabTemplate/@Name), '/definitions')" /><xsl:text disable-output-escaping="yes">"</xsl:text>
		<xsl:text disable-output-escaping="yes"> xmlns:xsd="</xsl:text><xsl:value-of select="'http://www.w3.org/2000/10/XMLSchema'" /><xsl:text disable-output-escaping="yes">"</xsl:text>
		<xsl:text disable-output-escaping="yes"> xmlns:xsdGeneric="</xsl:text><xsl:value-of select="'http://tempuri.org/IBM/WBI/genericSchemas'" /><xsl:text disable-output-escaping="yes">"</xsl:text>
		<xsl:text disable-output-escaping="yes"> xmlns:xsdWBI="</xsl:text><xsl:value-of select="concat('http://tempuri.org/IBM/WBI/', normalize-space(/CollabTemplate/@Name), '/schemas')" /><xsl:text disable-output-escaping="yes">"</xsl:text>		
		<xsl:text disable-output-escaping="yes"> xmlns:slnk="</xsl:text><xsl:value-of select="'http://schemas.xmlsoap.org/ws/2002/07/service-link/'" /><xsl:text disable-output-escaping="yes">"</xsl:text>
		<xsl:text disable-output-escaping="yes"> xmlns:bpws="</xsl:text><xsl:value-of select="'http://schemas.xmlsoap.org/ws/2002/07/business-process/'" /><xsl:text disable-output-escaping="yes">"</xsl:text>
		<xsl:text disable-output-escaping="yes"> xmlns="</xsl:text><xsl:value-of select="'http://schemas.xmlsoap.org/wsdl/'" /><xsl:text disable-output-escaping="yes">"></xsl:text>		

			<xsl:element name="import">
				<xsl:attribute name="namespace">
					<xsl:value-of select="concat('http://tempuri.org/IBM/WBI/', normalize-space(/CollabTemplate/@Name), '/schemas')" />
				</xsl:attribute>				
				<xsl:attribute name="location">
					<xsl:value-of select="concat(normalize-space(/CollabTemplate/@Name), '.xsd')" />
				</xsl:attribute>								
			</xsl:element>	
			
			<xsl:element name="types">
				<xsl:text disable-output-escaping="yes">
					&lt;schema  targetNamespace="http://tempuri.org/IBM/WBI/genericSchemas" xmlns="http://www.w3.org/2000/10/XMLSchema">
						&lt;element name="genericFault">
							&lt;complexType>
								&lt;sequence>
									&lt;element name="type" type="string" />
									&lt;element name="subType" type="string" />
									&lt;element name="description" type="string" />
								&lt;/sequence>
							&lt;/complexType>
						&lt;/element>												
					&lt;/schema>
				</xsl:text>
			</xsl:element>	

			<xsl:for-each select="xalan:distinct($nodePortMessages/tempServiceLinkType[IsRequestResponse/@type = 'Yes' or not(@IsNotUsed = 'Yes')]/@BusObjType)">				
				<xsl:variable name="strBOTypeName" select="normalize-space(.)" />
				<xsl:element name="message">
					<xsl:attribute name="name">
						<xsl:value-of select="concat($strBOTypeName, 'Message')" />
					</xsl:attribute>
											
					<xsl:element name="part">				
						<xsl:attribute name="name">
							<xsl:value-of select="$strBOTypeName" />
						</xsl:attribute>
						<xsl:attribute name="element">
							<xsl:value-of select="concat('xsdWBI:', $strBOTypeName)" />
						</xsl:attribute>
					</xsl:element>						
				</xsl:element>				
			</xsl:for-each>

			<xsl:element name="message">
				<xsl:attribute name="name">
					<xsl:value-of select="'genericFaultMessage'" />
				</xsl:attribute>
				
				<xsl:element name="part">				
					<xsl:attribute name="name">
						<xsl:value-of select="'genericFault'" />
					</xsl:attribute>
					<xsl:attribute name="element">
						<xsl:value-of select="'xsdGeneric:genericFault'" />
					</xsl:attribute>
				</xsl:element>				
			</xsl:element>	

			<xsl:for-each select="xalan:distinct($nodePortMessages/tempServiceLinkType[*]/*/tempPortType/@name)">
				<xsl:variable name="strBusObjName" select="../../../@BusObjType" />								
				<xsl:variable name="bHasTwoWayOperations" select="name(../..) = 'IsRequestResponse' or name(../..) = 'IsSolicitResponse'" />
				<xsl:variable name="bHasOneWayOperations" select="name(../..) = 'IsOneWay' or name(../..) = 'IsNotification'" />

				<xsl:if test="$bHasTwoWayOperations">
					<xsl:element name="portType">
						<xsl:attribute name="name">
							<xsl:value-of select="." />
						</xsl:attribute>														

						<xsl:for-each select="../tempOperations/tempOperation">						
							<xsl:element name="operation">				
								<xsl:attribute name="name">
									<xsl:value-of select="." />
								</xsl:attribute>

								<xsl:element name="input">
									<xsl:attribute name="name">
										<xsl:value-of select="concat(., 'Request')" />
									</xsl:attribute>									
									<xsl:attribute name="message">
										<xsl:value-of select="concat('tns:', $strBusObjName, 'Message')" />
									</xsl:attribute>									
								</xsl:element>
								<xsl:element name="output">
									<xsl:attribute name="name">
										<xsl:value-of select="concat(., 'Response')" />
									</xsl:attribute>									
									<xsl:attribute name="message">
										<xsl:value-of select="concat('tns:', $strBusObjName, 'Message')" />
									</xsl:attribute>									
								</xsl:element>
								<xsl:element name="fault">
									<xsl:attribute name="name">
										<xsl:value-of select="concat(., 'Fault')" />
									</xsl:attribute>									
									<xsl:attribute name="message">
										<xsl:value-of select="'tns:genericFaultMessage'" />
									</xsl:attribute>									
								</xsl:element>
							</xsl:element>
						</xsl:for-each>						
					</xsl:element>				
				</xsl:if>

				<xsl:if test="$bHasOneWayOperations">
					<xsl:element name="portType">
						<xsl:attribute name="name">
							<xsl:value-of select="." />
						</xsl:attribute>														

						<xsl:for-each select="../tempOperations/tempOperation">						
							<xsl:element name="operation">				
								<xsl:attribute name="name">
									<xsl:value-of select="." />
								</xsl:attribute>

								<xsl:element name="input">
									<xsl:attribute name="name">
										<xsl:value-of select="concat(., 'Request')" />
									</xsl:attribute>									
									<xsl:attribute name="message">
										<xsl:value-of select="concat('tns:', $strBusObjName, 'Message')" />
									</xsl:attribute>									
								</xsl:element>
							</xsl:element>
						</xsl:for-each>						
					</xsl:element>				
				</xsl:if>
			</xsl:for-each>

			<xsl:for-each select="$nodePortMessages/tempServiceLinkType">
				<xsl:variable name="bUsedPort" select="boolean(IsRequestResponse/@type = 'Yes' or not(@IsNotUsed = 'Yes'))" />

				<xsl:if test="$bUsedPort">
					<xsl:text disable-output-escaping="yes"> &lt;slnk:serviceLinkType name="</xsl:text><xsl:value-of select="normalize-space(@name)" /><xsl:text disable-output-escaping="yes">"></xsl:text>
						<xsl:if test="IsOneWay/@type = 'Yes' or IsRequestResponse/@type = 'Yes'">
							<xsl:text disable-output-escaping="yes"> &lt;slnk:role name="</xsl:text><xsl:value-of select="'providerRole'" /><xsl:text disable-output-escaping="yes">"></xsl:text>
								<xsl:if test="IsRequestResponse/@type = 'Yes'">
									<xsl:for-each select="IsRequestResponse/tempPortType">
										<xsl:text disable-output-escaping="yes"> &lt;slnk:portType></xsl:text>
											<xsl:value-of select="concat('tns:', @name)" />
										<xsl:text disable-output-escaping="yes"> &lt;/slnk:portType></xsl:text>
									</xsl:for-each>
								</xsl:if>
								
								<xsl:if test="IsOneWay/@type = 'Yes'">
									<xsl:for-each select="IsOneWay/tempPortType">
										<xsl:text disable-output-escaping="yes"> &lt;slnk:portType></xsl:text>
											<xsl:value-of select="concat('tns:', @name)" />
										<xsl:text disable-output-escaping="yes"> &lt;/slnk:portType></xsl:text>
									</xsl:for-each>
								</xsl:if>
							<xsl:text disable-output-escaping="yes"> &lt;/slnk:role></xsl:text>
						</xsl:if>

						<xsl:if test="IsNotification/@type = 'Yes' or IsSolicitResponse/@type = 'Yes'">
							<xsl:text disable-output-escaping="yes"> &lt;slnk:role name="</xsl:text><xsl:value-of select="'requesterRole'" /><xsl:text disable-output-escaping="yes">"></xsl:text>
								<xsl:if test="IsSolicitResponse/@type = 'Yes'">
									<xsl:for-each select="IsSolicitResponse/tempPortType">
										<xsl:text disable-output-escaping="yes"> &lt;slnk:portType></xsl:text>
											<xsl:value-of select="concat('tns:', @name)" />
										<xsl:text disable-output-escaping="yes"> &lt;/slnk:portType></xsl:text>
									</xsl:for-each>
								</xsl:if>
								
								<xsl:if test="IsNotification/@type = 'Yes'">
									<xsl:for-each select="IsNotification/tempPortType">
										<xsl:text disable-output-escaping="yes"> &lt;slnk:portType></xsl:text>
											<xsl:value-of select="concat('tns:', @name)" />
										<xsl:text disable-output-escaping="yes"> &lt;/slnk:portType></xsl:text>
									</xsl:for-each>
								</xsl:if>
							<xsl:text disable-output-escaping="yes"> &lt;/slnk:role></xsl:text>
						</xsl:if>
					<xsl:text disable-output-escaping="yes"> &lt;/slnk:serviceLinkType> </xsl:text>					
				</xsl:if>
				
			</xsl:for-each>

			

			<xsl:for-each select="xalan:distinct(/CollabTemplate/Scenarios/Scenario[*]/ModelScenario/Diagram[*]/DiagramBody/Nodes/*//CorrelationSet[@IsInit = 'Yes']/CorrelationAttribute[*]/VariableName)">
				
				<xsl:variable name="strVariableName" select="normalize-space(.)" />
				<xsl:variable name="nodeTabularEditorVariables" select="/CollabTemplate/GUITemplateDefinition/GUIVariables/GUIVariable[normalize-space(VarName) = $strVariableName]" />
				<xsl:if test="count($nodeTabularEditorVariables) &gt; 1">
					
					<xsl:message terminate="yes">
						<xsl:value-of select="concat('Invalid template. It has more than one definition for variable: ', $strVariableName)" />
					</xsl:message>
				</xsl:if>

				<xsl:choose>
					<xsl:when test="count($nodeTabularEditorVariables) = 1">
						<xsl:variable name="strVarType" select="normalize-space($nodeTabularEditorVariables/VarType)" />
						<xsl:choose>
							<xsl:when test="$nodeTabularEditorVariables/ObjectType/@NeedsTwoStepInit = 'No'">
								<xsl:choose>
									<xsl:when test="$strVarType = 'int' or $strVarType = 'Integer'">
										<xsl:text disable-output-escaping="yes"> &lt;bpws:property name="</xsl:text><xsl:value-of select="$strVariableName" /><xsl:text disable-output-escaping="yes">" type="xsd:long" /></xsl:text>
									</xsl:when>
									<xsl:when test="$strVarType = 'boolean' or $strVarType = 'Boolean'">
										<xsl:text disable-output-escaping="yes"> &lt;bpws:property name="</xsl:text><xsl:value-of select="$strVariableName" /><xsl:text disable-output-escaping="yes">" type="xsd:boolean" /></xsl:text>
									</xsl:when>
									<xsl:when test="$strVarType = 'float' or $strVarType = 'Float'">
										<xsl:text disable-output-escaping="yes"> &lt;bpws:property name="</xsl:text><xsl:value-of select="$strVariableName" /><xsl:text disable-output-escaping="yes">" type="xsd:float" /></xsl:text>
									</xsl:when>
									<xsl:when test="$strVarType = 'double' or $strVarType = 'Double'">
										<xsl:text disable-output-escaping="yes"> &lt;bpws:property name="</xsl:text><xsl:value-of select="$strVariableName" /><xsl:text disable-output-escaping="yes">" type="xsd:double" /></xsl:text>
									</xsl:when>
									<xsl:when test="$strVarType = 'String' ">
										<xsl:text disable-output-escaping="yes"> &lt;bpws:property name="</xsl:text><xsl:value-of select="$strVariableName" /><xsl:text disable-output-escaping="yes">" type="xsd:string" /></xsl:text>
									</xsl:when>
									<xsl:when test="$strVarType = 'Date'">
										<xsl:text disable-output-escaping="yes"> &lt;bpws:property name="</xsl:text><xsl:value-of select="$strVariableName" /><xsl:text disable-output-escaping="yes">" type="xsd:datetime" /></xsl:text>
									</xsl:when>
									<xsl:otherwise>
										<xsl:message terminate="yes">
											<xsl:value-of select="concat('Invalid template. It has invalid data type for a property: ', $strVariableName)" />
										</xsl:message>								
									</xsl:otherwise>
								</xsl:choose>
							</xsl:when>
							<xsl:otherwise>
								<xsl:message terminate="yes">
									<xsl:value-of select="concat('Invalid template. It has invalid data type for a property: ', $strVariableName)" />
								</xsl:message>								
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:message terminate="yes">
							<xsl:value-of select="concat('Invalid template. Unable to find the data type for a property: ', $strVariableName)" />
						</xsl:message>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:for-each>

			<xsl:variable name="treePropertyAlias">
				<xsl:for-each select="/CollabTemplate/Scenarios/Scenario[*]/ModelScenario/Diagram[*]/DiagramBody/Nodes/*[.//CorrelationSet]">				
					<xsl:choose>
						<xsl:when test="name(.) = 'InitialNode'">						
							<xsl:variable name="strPortName" select="substring-before(CorrelationSet/CorrelationAttribute/AttributeName, 'BusObj.')" />
							<xsl:variable name="strMessageType" select="$nodePortMessages/tempServiceLinkType[@name = $strPortName]/@BusObjType" />

							<xsl:if test="not($strMessageType = '')">
								<xsl:for-each select="./CorrelationSet/CorrelationAttribute">
									<xsl:element name="pd.property.alias">
										<xsl:attribute name="pd.property">
											<xsl:value-of select="VariableName" />
										</xsl:attribute>
										<xsl:attribute name="pd.message">
											<xsl:value-of select="$strMessageType" />										
										</xsl:attribute>
										<xsl:attribute name="pd.part.query">
											<xsl:value-of select="normalize-space(substring-after(AttributeName, 'BusObj.'))" />										
										</xsl:attribute>
										<xsl:attribute name="pd.unique.id">
											<xsl:value-of select="concat(normalize-space($strMessageType), normalize-space(substring-after(AttributeName, 'BusObj.')))" />										
										</xsl:attribute>
									</xsl:element>
								</xsl:for-each>
							</xsl:if>											
						</xsl:when>
						<xsl:otherwise>
							<!-- can be one of the service node types.  -->
							<xsl:variable name="strPortName" select="./ServiceNode/RegBusObjRefName" />
							<xsl:variable name="strMessageType" select="$nodePortMessages/tempServiceLinkType[@name = $strPortName]/@BusObjType" />

							<xsl:if test="not($strMessageType = '')">
								<xsl:for-each select="./ServiceNode/CorrelationSet/CorrelationAttribute">
									<xsl:element name="pd.property.alias">
										<xsl:attribute name="pd.property">
											<xsl:value-of select="VariableName" />
										</xsl:attribute>
										<xsl:attribute name="pd.message">
											<xsl:value-of select="$strMessageType" />										
										</xsl:attribute>
										<xsl:attribute name="pd.part.query">
											<xsl:value-of select="normalize-space(AttributeName)" />										
										</xsl:attribute>
										<xsl:attribute name="pd.unique.id">
											<xsl:value-of select="concat(normalize-space($strMessageType), normalize-space(AttributeName))" />										
										</xsl:attribute>
									</xsl:element>
								</xsl:for-each>
							</xsl:if>
						</xsl:otherwise>
					</xsl:choose>				
				</xsl:for-each>
			</xsl:variable>

			<xsl:variable name="nodePropertyAlias" select="xalan:nodeset($treePropertyAlias)" />
			
			<xsl:for-each select="xalan:distinct($nodePropertyAlias/pd.property.alias/@pd.unique.id)">
				<xsl:text disable-output-escaping="yes"> &lt;bpws:propertyAlias propertyName="tns:</xsl:text><xsl:value-of select="normalize-space(./../@pd.property)" /><xsl:text disable-output-escaping="yes">" messageType="tns:</xsl:text><xsl:value-of select="normalize-space(.//../@pd.message)" /><xsl:text disable-output-escaping="yes">Message" part="</xsl:text><xsl:value-of select="normalize-space(.//../@pd.message)" /><xsl:text disable-output-escaping="yes">" query="/</xsl:text><xsl:value-of select="normalize-space(.//../@pd.part.query)" /><xsl:text disable-output-escaping="yes">" /></xsl:text>
			</xsl:for-each>
				

		<xsl:text disable-output-escaping="yes">
			&lt;/definitions>
		</xsl:text>
	</xsl:template>	
<!-- *** Design Document ***

	1. Import the BO tpye definitions schema into this definitions wsdl file.
		assumption: there will be an xsd file which will have all used BO type definitions grouped together

	2. create a wsdl types element in which all generic type schemas will be defined like the generic fault type

	3. add wsdl message elements for each unique reffered BO types in all really used collaboration ports.

	4. then add a message element for our generic fault type

	5. create a wsdl portType per unique generated port type name, then add operations per verbs used under those ports, with input/output/fault messages for two way operations and input message for oneway operations

	6. create wsdl extension service link type per used collaboration ports, with one role "providerRole" for request-response and one way operation ports, and another role 'requesterRole' for Notification and solicit-response operations ports.

	7. Create a property for each correlation variable used in the correlation set intialization.

	8. Create a propertyAlias for each BO type that is used in conjunction with the correlation set.

	 *** Design Document ***
-->

</xsl:stylesheet>
